;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; deklaracje zmiennych globalnych systemu makr G8GeoCad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(setq *g8geocad-zstyle* -1.0) ; ustala traktowanie wsprzdnej z podczas operacji importu i exportu gdy rysunek jest w globalnym ukadzie wsprzdnych.
(setq *g8geocad-xystyle* 1.0) ; ustala traktowanie wsprzdnych x i y podczas operacji importu i exportu gdy rysunek jest w globalnym ukadzie wsprzdnych.
(setq *g8geocad-atrstyle* 1.0) ; ustala traktowanie atrybutu h gdy wstawiamy punkt w globalnym ucs
(setq *g8geocad-dx*    0.5)  ; odlego midzy x punktu wstawienia bloku a atrybutami 
(setq *g8geocad-dy*    0.5)  ; odlego midzy y punktu wstawienia bloku a atrybutami
(setq *g8geocad-hname* 0.9)  ; wysoko tekstu atrybutu "Nazwa"
(setq *g8geocad-hh*    0.9)  ; wysoko tekstu atrybutu "H"
(setq *g8geocad-import* nil) ; nazwa ostatnio wybranego pliku do importu
(setq *g8geocad-export* "punkty.txt") ; nazwa ostatnio wybranego pliku do eksportu
(setq *g8geocad-nrpocz* "1") ; nazwa domylnego numeru przy pierwszym wywoaniu funkcji Gstar8-wstaw-z-listy2
(setq *g8geocad-uwl* "0")    ; ustawienie toggla w funkcji Gstar8-wstaw-z-listy2 - "uwzgldnij wielko liter"

;*g8geocad-blok*
;*g8geocad-nazwa*

(setq *g8geocad-format* "%lu2%pr2")
;(setq *g8geocad-format* "%lu2%pt3%pr2")


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; funkcje pomocnicze
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(vl-load-com)

(defun alert+close+error (msg plik)
  (alert msg)
  (if plik (close plik))
  (exit)
);defun alert+close+error

(defun ciagzer (n / %)
  (setq % "")
  (repeat n (setq % (strcat % "0")))
  %
);defun ciagzer

(defun ciagspacji (n / %)
  (setq % "")
  (repeat n (setq % (strcat % " ")))
  %
);defun ciagspacji

(defun urtos (r typ d / # s pk pe) 
  (if (or (zerop d) (/= typ 2))
    (rtos r typ d)
    (progn
      (setq aa (list r d))
      (setq s (rtos r 2 d) pk (vl-string-position (ascii ".") s) pe (vl-string-position (ascii "E") s))
      (if (null pe)
        (if pk
          (if (zerop (setq # (- d (- (strlen s) pk 1))))  s  (strcat s (ciagzer #)))
          (strcat s "." (ciagzer d))
        )
        (if pk
          (if (zerop (setq # (- d (- pe pk 1)))) s (strcat (substr s 1 pe) (ciagzer #) (substr s (1+ pe))))
          (strcat (substr s 1 pe) "." (ciagzer d) (substr s (1+ pe)))
        )
      )
    )
  )
);defun urtos

(defun Gstar8-internal-s ( / ans)
  (if (wcmatch (strcase (getvar "ACADPREFIX")) "*GSTARCAD*")
    (setq ans "Gstar8-1011")
    (setq ans "G8GeoCad")
  )
  (if (= "acad" (getvar "PROGRAM"))
    (setq ans "G8GeoCad")
  ) 
  ans
);defun Gstar8-internal-s



(defun Gstar8-numer (ob / obn obnl)
  (if (and (setq obn (entnext ob)) (setq obnl (entget obn)) (= "ATTRIB" (cdr (assoc 0 obnl))) (wcmatch (strcase(cdr (assoc 2 obnl))) "NAZWA,GEODBLOCK*ATTR"))
    (cdr (assoc 1 obnl)))
);defun Gstar8-numer

(defun Gstar8-h (ob / obn obnn obnnl)
  (if (and (setq obn (entnext ob)) (setq obnn (entnext obn)) (setq obnnl (entget obnn)) (= "ATTRIB" (cdr (assoc 0 obnnl))) (wcmatch (strcase(cdr (assoc 2 obnnl))) "H,GEODBLOCK*ATTR"))
    (cdr (assoc 1 obnnl)))
);defun Gstar8-h

(defun Gstar8-ucs-test ( / warn wz)
  (setq warn "")
  (if (not (equal (getvar "UCSORG") '(0 0 0) 0.000001))
    (setq warn "\n- aktualny lokalny ukad wsprzednych ma poczatek w innym punkcie niz 0,0,0.")
  )
  (if (equal (trans '(0 0 1) 0 1 0) '(0 0 -1) 0.000001)
    (setq wz -1 warn (if (not (equal (getvar "UCSXDIR") '(0 1 0) 0.000001)) (strcat warn "\n- lokalny ukad wsprzednych jest obrcony wok osi OZ.") warn))
    (if (equal (trans '(0 0 1) 0 1 0) '(0 0 1) 0.000001)
      (setq wz 1 warn (if (not (equal (getvar "UCSXDIR") '(1 0 0) 0.000001)) (strcat warn "\n- lokalny ukad wsprzednych jest obrcony wok osi OZ.") warn))
      (alert+close+error "Bd! Aktualny ukad wsprzednych jest obrcony wok osi OX lub OY o kt inny niz 0g lub 200g." nil )
    )
  )
  (if (/= warn "")
    (alert (strcat "Ostrzezenie !" warn))
  )
  wz
);defun Gstar8-ucs-test

(defun is-real-or-int (% / #)
  (setq # (read %))
  (setq # (type #))
  (or (equal # 'REAL) (equal # 'INT))
);defun is-real-or-int

(defun usun-spacje (% / x)
  (if (= % "")
    %
    (progn
      (setq x (vl-remove (ascii "\t") (vl-string->list %)))
      (if x (setq x (vl-remove (ascii " ") x)))
      (if x (vl-list->string x) "")
    )
  )
);defun usun-spacje

(defun next-number (numer / znak dl znakpoprz)
  (setq dl (strlen numer))
  (setq znak (substr numer dl 1))
  (if (= dl 1)
    (progn
      (if (and (>= znak "0") (<= znak "9"))
        (eval (itoa (+ 1 (atoi znak))))
        (eval znak)
      )
    )
    (progn
      (if (and (>= znak "0") (<= znak "8"))
        (eval (strcat (substr numer 1 (- dl 1)) (itoa (+ 1 (atoi znak)))))
        (progn
          (if (= znak "9")
            (progn
              (setq znakpoprz (substr numer (- dl 1) 1))
              (if (and (>= znakpoprz "0") (<= znakpoprz "9"))
                (eval (strcat (next-number (substr numer 1 (- dl 1))) "0"))
                (eval (strcat (substr numer 1 (- dl 1)) "10"))
              )
            )
            (eval (strcat (next-number (substr numer 1 (- dl 1))) znak))
          )
        )
      )
    )  
  )
);defun next-number

(defun listaent (% l / wyn m)
  (while (setq m (member (assoc % l) l))
    (setq wyn (cons (cdar m) wyn))
    (setq l (cdr m))
  )
  (reverse wyn)
);defun listaent

(defun spr-globals ()
  (if (and *g8geocad-zstyle* (or (equal *g8geocad-zstyle* 1.0 0.0000001) (equal *g8geocad-zstyle* -1.0 0.0000001)))
    (not nil)
    (alert+close+error "\Bdna warto zmiennych globalnych.")
  )
);defun spr-globals

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Makro tworzce definicje blokw
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Gstar8-insert-preview (blok-name)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (if (not (tblsearch "STYLE" "GeodText"))
    (entmake '((0 . "STYLE")(100 . "AcDbSymbolTableRecord")(100 . "AcDbTextStyleTableRecord")(2 . "GeodText")(70 . 0)(40 . 0.0)(41 . 1.0)(50 . 0.25)(71 . 0)(42 . 2.5)(3 . "romans.shx")(4 . "")))
  )
  (if (not (tblsearch "BLOCK" blok-name))
    (progn
      ;(if (wcmatch "" "")
      (if (wcmatch (strcase blok-name) "OWN *")
         (progn
      (lc:insertowns blok-name)


         )
         (progn
      (entmake (list '(0 . "BLOCK")'(100 . "AcDbEntity")'(8 . "0")'(100 . "AcDbBlockBegin")'(70 . 2)(cons 2 blok-name)'(10 0.0 0.0 0.0)))
      (entmake (list '(0 . "ATTDEF")'(100 . "AcDbEntity")'(8 . "0")'(62 . 0)'(6 . "Continuous")'(370 . -2)'(100 . "AcDbText")
               (list 10  *g8geocad-dx* (if (= blok-name "GeodPik")(* -1.0 *g8geocad-dy*) *g8geocad-dy*) 0.0)
               '(40 . 1.8)'(1 . "???")'(50 . 0.0)'(41 . 1.0)'(51 . 0.25)'(7 . "GeodText")
               '(71 . 0)'(72 . 0)'(11 0.0 0.0 0.0)'(210 0.0 0.0 1.0)'(100 . "AcDbAttributeDefinition")'(3 . "Podaj nazw punktu")'(2 . "Nazwa")
               '(70 . 4)'(73 . 0)'(74 . 0)))
      (entmake (list '(0 . "ATTDEF")'(100 . "AcDbEntity")'(8 . "0")'(62 . 0)'(6 . "Continuous")(if (= blok-name "GeodPik") '(60 . 0) '(60 . 1))
               '(370 . -2)'(100 . "AcDbText")(list 10 *g8geocad-dx* (if (= blok-name "GeodPik")*g8geocad-dy*(* -1.0 *g8geocad-dy*)) 0.0)
               '(40 . 1.8)'(1 . " ")'(50 . 0.0)'(41 . 1.0)'(51 . 0.25)'(7 . "GeodText")
               '(71 . 0)'(72 . 0)'(11 0.0 0.0 0.0)'(210 0.0 0.0 1.0)'(100 . "AcDbAttributeDefinition")'(3 . "Podaj rzdn")'(2 . "H")
               '(70 . 1)'(73 . 0)'(74 . 0)))
      (cond
        ((= blok-name "GeodPkt")
         (entmake '((0 . "POINT")(8 . "0")(62 . 0)(6 . "Continuous")(370 . -2)(10 0.0 0.0 0.0)))
        )
        ((= blok-name "GeodPktEw")
         (entmake '((0 . "CIRCLE")(100 . "AcDbEntity")(8 . "0")(62 . 0)(6 . "Continuous")(370 . -2)(100 . "AcDbCircle")(10 0.0 0.0 0.0)(40 . 0.6)(210 0.0 0.0 1.0)))
        )
        ((= blok-name "GeodPik")
         (entmake '((0 . "CIRCLE")(100 . "AcDbEntity")(8 . "0")(62 . 0)(6 . "Continuous")(370 . -2)(100 . "AcDbCircle")(10 0.0 0.0 0.0)(40 . 0.12)(210 0.0 0.0 1.0)))
        )
        ((= blok-name "GeodOsn")
         (entmake '((0 . "CIRCLE")(100 . "AcDbEntity")(8 . "0")(62 . 0)(6 . "Continuous")(370 . -2)(100 . "AcDbCircle")(10 0.0 0.0 0.0)(40 . 0.8)(210 0.0 0.0 1.0)))
         (entmake '((0 . "CIRCLE")(100 . "AcDbEntity")(8 . "0")(62 . 0)(6 . "Continuous")(370 . -2)(100 . "AcDbCircle")(10 0.0 0.0 0.0)(40 . 0.08)(210 0.0 0.0 1.0)))
        )
      )
      (entmake '((0 . "ENDBLK")))
      )
      )
    )
  )
);defun Gstar8-insert-preview

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Wstawianie bloku - wewntrzne
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    
(defun Gstar8-insert-internal (blok pokaz-blok pokaz-opis globalx globaly globalz skala nazwa h / pokaz-h)
  (if (not (setq pokaz-h (vlax-ldata-get (strcat "Gstar8" blok) "blokh" nil (not nil))))
    (setq pokaz-h 1)
    (if (/= (type pokaz-h) 'REAL) (setq pokaz-h (atof pokaz-h)))
  )
  (if (wcmatch (strcase blok) "OWN *")
    (progn
    (setq blk (vla-insertblock (vla-get-modelspace docRef)
      (list->variantArray (list globalx globaly globalz))
      blok skala skala skala 0.0))

    (if (and
          (= (vla-get-hasattributes blk) :vlax-true)
          (safearray-value
            (setq atts (vlax-variant-value (vla-getattributes blk)))
          )
        )
    (progn
      (vlax-for ent (vla-get-blocks docRef)
        (if (= (vla-get-name ent) (vla-get-name blk))
          (progn
            ;; place
            (foreach tag (vlax-safearray->list atts)
              (if (wcmatch (strcase (vla-get-TagString tag)) "POSITION")
                (progn
                  (setq blk_id (Get-ObjectID-x86-x64 blk))
                  (vla-put-TextString
                    tag
                    (strcat "%<\\AcObjProp Object(%<\\_ObjId " blk_id ">%).InsertionPoint \\f \"" *g8geocad-format* "\">%")
                  )
                ) 
              )
              (if (wcmatch (strcase (vla-get-TagString tag)) "NAZWA")
                (progn
                  (vla-put-TextString tag nazwa)
                  (vla-put-Visible tag (if (equal pokaz-opis 0 0.001) :vlax-false :vlax-true))
                )
              )
            )
          )
        )          
      )
    )
  )
  )
  (progn
    (setq ob (entmake (list '(0 . "INSERT")'(66 . 1)(cons 2 blok)(cons 41 skala)(cons 42 skala)(cons 43 skala)(list 10 globalx globaly globalz)'(50 . 0.0))))
    (entmake (list '(0 . "ATTRIB")'(100 . "AcDbEntity")
                   (if (equal pokaz-opis 0 0.001) '(60 . 1) '(60 . 0))
                   '(8 . "0")'(62 . 0)'(370 . -2)'(100 . "AcDbText")
                   (if (/= blok "GeodPik")
                     (list 10 (+ globalx (* skala *g8geocad-dx*)) (+ globaly (* skala *g8geocad-dy*)) globalz)
                     (list 10 (+ globalx (* skala *g8geocad-dx*)) (- globaly (* skala *g8geocad-dy*)) globalz)
                   )
                   (cons 40 (* skala *g8geocad-hname*))(cons 1 nazwa)'(50 . 0.0)'(51 . 0.25)'(7 . "GeodText")'(71 . 0)'(72 . 0)'(100 . "AcDbAttribute")'(2 . "Nazwa")'(70 . 0)'(73 . 0)'(74 . 0)))
    (entmake (list '(0 . "ATTRIB")'(100 . "AcDbEntity")
                   (if (= blok "GeodPik") 
                       (if (equal pokaz-h 0 0.001) '(60 . 1) '(60 . 0)) 
                       '(60 . 1)
                    )
                   '(8 . "0")'(62 . 0)'(370 . -2)'(100 . "AcDbText")
                   (if (= blok "GeodPik")
                     (list 10 (+ globalx (* skala *g8geocad-dx*)) (+ globaly (* skala *g8geocad-dy*)) globalz)
                     (list 10 (+ globalx (* skala *g8geocad-dx*)) (- globaly (* skala *g8geocad-dy*)) globalz)
                   )
                   (cons 40 (* skala *g8geocad-hh*))(cons 1 h)'(50 . 0.0)'(51 . 0.25)'(7 . "GeodText")'(71 . 0)'(72 . 0)'(100 . "AcDbAttribute")'(2 . "H")(if (= blok "GeodPik") '(70 . 0) '(70 . 1))'(73 . 0)'(74 . 0)))  
    (entmake '((0 . "SEQEND")))
  )
  )

);defun Gstar8-insert-internal

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Wstawianie bloku - ostateczne
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Gstar8-geodpkt ( blok / p skala pokaz-blok pokaz-nazwe nazwa wz)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (setq wz (Gstar8-ucs-test))
  (spr-globals)
  (command "_UNDO" "_M")
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (exit))
  (Gstar8-insert-preview blok)
  (if (not (setq skala (vlax-ldata-get (strcat "Gstar8" blok) "skala" nil (not nil))))
    (setq skala 1.0)
    (if (/= (type skala) 'REAL) (setq skala (atof skala)))
  )
  (if (not (setq pokaz-nazwe (vlax-ldata-get (strcat "Gstar8" blok) "nazwa" nil (not nil))))
    (setq pokaz-nazwe 1)
    (if (/= (type pokaz-nazwe) 'REAL) (setq pokaz-nazwe (atof pokaz-nazwe)))
  )
  (while (setq p (getpoint "\nWska punkt >"))   
    (setq p (trans p 1 0))
    (setq nazwa (getstring "\nPodaj numer punktu >"))
    (Gstar8-insert-internal blok pokaz-blok pokaz-nazwe (car p) (cadr p) (caddr p) skala nazwa (urtos (* -1.0 (if (= wz 1) *g8geocad-atrstyle* 1.0)(caddr p)) 2 2))    
    (setq *g8geocad-blok* blok)
    (setq *g8geocad-nazwa* nazwa)
  )
  (princ)
);defun Gstar8-geodpkt

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Wstawianie bloku - ostateczne
; next
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Gstar8-geodpkt-next ( / p skala pokaz-blok pokaz-nazwe nazwa wz)
  (if (equal (type *g8geocad-blok*) 'STR)
    (setq blok *g8geocad-blok*)
    (setq blok "GeodPkt")
  )
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (setq wz (Gstar8-ucs-test))
  (spr-globals)
  (command "_UNDO" "_M")
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (exit))
  (Gstar8-insert-preview blok)
  (if (not (setq skala (vlax-ldata-get (strcat "Gstar8" blok) "skala" nil (not nil))))
    (setq skala 1.0)
    (if (/= (type skala) 'REAL) (setq skala (atof skala)))
  )
  (if (not (setq pokaz-nazwe (vlax-ldata-get (strcat "Gstar8" blok) "nazwa" nil (not nil))))
    (setq pokaz-nazwe 1)
    (if (/= (type pokaz-nazwe) 'REAL) (setq pokaz-nazwe (atof pokaz-nazwe)))
  )
  (while (setq p (getpoint "\nWska punkt >"))   
    (setq p (trans p 1 0))
    (if (equal (type *g8geocad-nazwa*) 'STR)
      (setq nazwa *g8geocad-nazwa*)
      (setq nazwa "0")
    )
    (setq nazwa (incr-nazwa nazwa))

    (Gstar8-insert-internal blok pokaz-blok pokaz-nazwe (car p) (cadr p) (caddr p) skala nazwa (urtos (* -1.0 (if (= wz 1) *g8geocad-atrstyle* 1.0)(caddr p)) 2 2))    
    (setq *g8geocad-nazwa* nazwa)
  )
  (princ)
);defun Gstar8-geodpkt-next

(defun incr-nazwa (nazwa)
  (setq pos (strlen nazwa))
  (while (and (> (setq sym (ascii (substr nazwa pos 1))) 47) (< sym 58))
    (setq pos (1- pos))
  )
  (setq snum (substr nazwa (1+ pos)))
  (if (> (strlen snum) 0) 
    (strcat (substr nazwa 1 pos) (itoa (1+ (atoi snum))))
    nazwa
  )
);defun incr-nazwa

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ustawianie geodezyjnego ukadu wsprzdnych
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Gstar8-geoducs ()
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (if (not ( = (getvar "UCSNAME") "Geod"))
    (progn
      (if (not (tblsearch "UCS" "Geod"))
        (entmake '((0 . "UCS")(100 . "AcDbSymbolTableRecord")(100 . "AcDbUCSTableRecord")(2 . "Geod")(70 . 0)(10 0.0 0.0 0.0)(11 0.0 1.0 0.0)(12 1.0 0.0 0.0)(79 . 0)(146 . 0.0)))
      )
      (command "_UCS" "_Restore" "Geod")
    )
  )
  (if (not (equal (getvar "UCSORG") '(0 0 0) 0.000001))
      (command "_UCS" "_Move" (trans '(0 0 0) 0 1))
  )
);defun Gstar8-geoducs

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; import punktw geodezyjnych
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Gstar8-geodimport ( txt / % # a n dcl-id plik plik-sys prec dkl warn opcjan opcjaxy opcjaz blok linia linia2 el1 el2 el3 el4 test numer x y z p wz)
  (vl-load-com)
  (setq docRef (vla-get-activedocument (vlax-get-acad-object)))

  (setq warn "")
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (spr-globals)
  (if (not (equal (getvar "UCSORG") '(0 0 0) 0.000001))
    (setq warn "\n- aktualny lokalny ukad wsprzednych ma poczatek w innym punkcie niz 0,0,0.")
  )
  (if (equal (trans '(0 0 1) 0 1 0) '(0 0 -1) 0.000001)
    (setq wz -1 warn (if (not (equal (getvar "UCSXDIR") '(0 1 0) 0.000001)) (strcat warn "\n- lokalny ukad wsprzednych jest obrcony wok osi OZ.") warn))
    (if (equal (trans '(0 0 1) 0 1 0) '(0 0 1) 0.000001)
      (setq wz 1 warn (if (not (equal (getvar "UCSXDIR") '(1 0 0) 0.000001)) (strcat warn "\n- lokalny ukad wsprzednych jest obrcony wok osi OZ.") warn))
      (progn (alert "Bd! Aktualny ukad wsprzednych jest obrcony wok osi OX lub OY o kt inny niz 0g lub 200g.") (exit))
    )
  )
  (if (/= warn "")
    (alert (strcat "Ostrzezenie !" warn))
  )
  (command "_UNDO" "_M")
  (if (setq plik (getfiled "G8GeoCad: Import Punktw" (if *g8geocad-import* *g8geocad-import* "") (if txt "txt" "") 0))
    (progn
      (setq *g8geocad-import* plik)
      (setq dcl-id (load_dialog "Gstar8GeoImport.dcl"))  ;Load the dialog box.
      (if (< dcl-id 0)
        (progn
          (alert "Bd przy probie otwarcia pliku Gstar8GeoImport.dcl")
          (exit)
        )
      )
      (if (null (new_dialog "import_dialog_1" dcl-id)) ;Initialize dialog
        (progn
          (alert "Bd aktywacji okna \"import_dialog_1\"")
          (exit)
        )
      )
      (set_tile "d1text1" plik)
      (set_tile "d1popup" "2")
      (if (= opcjaz "0") (mode_tile "d1popup" 1))
      (action_tile "d1tg4" "(if (= \"0\" (get_tile \"d1tg4\"))(mode_tile \"d1popup\" 1)(mode_tile \"d1popup\" 0))")
      (action_tile "accept" "(reakcjad1)")
      (if (= 1 (start_dialog))
        (progn
              (setq plik-sys (open plik "r"))
              (if (not plik-sys) (progn (alert (strcat "Bd otwarcia pliku :" plik)) (exit)))
              (setq n 0)
              (while (setq linia (read-line plik-sys))
                (if (/= "" (usun-spacje linia))
                (progn
                (setq a (vl-string->list linia))
                (setq a (mapcar '(lambda(%) (if (= % (ascii "\t")) (ascii " ") %)) a))
                (setq a (mapcar '(lambda(%) (if (= % (ascii ",")) (ascii ".") %)) a))
                (setq linia2 (vl-list->string a))
                (setq linia2 (strcat (vl-string-left-trim " " linia2) " "))
                (setq # (vl-string-search " " linia2))
                (setq el1 (substr linia2 1 #))
                (if (= el1 "")
                  (progn (alert (strcat "Bld w wierszu nr: " (itoa (+ n 1)) "\n" linia "\nWczytano dotychczas " (itoa n) " punktw." )) (close plik-sys) (exit))
                )
                (setq linia2 (substr linia2 (1+ #)))
                (setq linia2 (vl-string-left-trim " " linia2))
                (setq # (vl-string-search " " linia2))
                (setq el2 (substr linia2 1 #))
                (if (= el2 "")
                  (progn (alert (strcat "Bld w wierszu nr: " (itoa (+ n 1)) "\n" linia "\nWczytano dotychczas " (itoa n) " punktw." )) (close plik-sys) (exit))
                )
                (setq linia2 (substr linia2 (1+ #)))
                (setq linia2 (vl-string-left-trim " " linia2))
                (setq # (vl-string-search " " linia2))
                (setq el3 (substr linia2 1 #))
                (if (/= el3 "")
                  (progn
                    (setq linia2 (substr linia2 (1+ #)))
                    (setq linia2 (vl-string-left-trim " " linia2))
                    (setq # (vl-string-search " " linia2))
                    (setq el4 (substr linia2 1 #))
                  )
                )
                (if (= "0" opcjan)
                  (setq numer " ")
                  (setq numer el1)
                )
                (if (= "0" opcjan)
                  (setq x (if (is-real-or-int el1)
                            (atof el1)
                            (progn(alert(strcat "Bld w wierszu nr: " (itoa (+ n 1)) "\n" linia "\nWczytano dotychczas " (itoa n) " punktw."))(close plik-sys) (exit)))
                        y (if (is-real-or-int el2)
                            (atof el2)
                            (progn(alert(strcat "Bld w wierszu nr: " (itoa (+ n 1)) "\n" linia "\nWczytano dotychczas " (itoa n) " punktw."))(close plik-sys) (exit)))
                        z (if (= opcjaz "0")
                            0.0
                            (if (= "" el3)
                              0.0
                              (if (is-real-or-int el3)
                                (atof el3)
                                (progn(alert(strcat "Bld w wierszu nr: " (itoa (+ n 1)) "\n" linia "\nWczytano dotychczas " (itoa n) " punktw."))(close plik-sys) (exit))
                              )
                            )
                          )
                  ) ; setq
                  (setq x (if (is-real-or-int el2)
                            (atof el2)
                            (progn(alert(strcat "Bld w wierszu nr: " (itoa (+ n 1)) "\n" linia "\nWczytano dotychczas " (itoa n) " punktw."))(close plik-sys) (exit)))
                        y (if (and (/= el3 "") (is-real-or-int el3))
                            (atof el3)
                            (progn(alert(strcat "Bld w wierszu nr: " (itoa (+ n 1)) "\n" linia "\nWczytano dotychczas " (itoa n) " punktw."))(close plik-sys) (exit)))
                        z (if (= opcjaz "0")
                            0.0
                            (if (= "" el4)
                              0.0
                              (if (is-real-or-int el4)
                                (atof el4)
                                (progn(alert(strcat "Bld w wierszu nr: " (itoa (+ n 1)) "\n" linia "\nWczytano dotychczas " (itoa n) " punktw."))(close plik-sys) (exit))
                              )
                            )
                          )
                  ) ; setq
                ) ; if

                (Gstar8-insert-preview blok)
                (if (not (setq skala (vlax-ldata-get (strcat "Gstar8" blok) "skala" nil (not nil))))
                  (setq skala 1.0)
                  (if (/= (type skala) 'REAL) (setq skala (atof skala)))
                )
                (if (not (setq pokaz-nazwe (vlax-ldata-get (strcat "Gstar8" blok) "nazwa" nil (not nil))))
                  (setq pokaz-nazwe 1)
                  (if (/= (type pokaz-nazwe) 'REAL) (setq pokaz-nazwe (atof pokaz-nazwe)))
                )
                (if (= prec "0")
                  (setq dkl 0)
                  (setq dkl (- (strlen prec) 2))
                )
                (if (and (= wz 1) (= *g8geocad-xystyle* -1))
                  (if (= opcjaxy "0")
                    (setq opcjaxy "1")
                    (setq opcjaxy "0")
                  )
                )
                (if (= opcjaxy "1")
                  (setq # x x y y #)
                )
                (if (= wz 1)
                  (setq p (trans (list y x z) 1 0))
                  (setq p (trans (list x y z) 1 0))
                )
                (if (= wz 1)
                  (setq z (* z *g8geocad-zstyle*))
                )
                (Gstar8-insert-internal blok nil pokaz-nazwe (car p) (cadr p) (* -1.0 z) skala numer (if (= opcjaz "0") " " (urtos (* -1.0 z) 2 dkl)))
                (setq n (1+ n))
                (if (= 0 (rem n 100))
                  (if (> n 0) (prompt (strcat "\nWczytano " (itoa n) " punktow."))
                  )
                )
                );progn
                );if
              );while
              (alert (strcat "Wczytano : " (itoa n) " punktw."))
              (close plik-sys)
            )
      )
      (unload_dialog dcl-id)
      (princ)
    )
  )
);defun Gstar8-import

(defun reakcjad1 ()
  (setq opcjan (get_tile "d1tg1")  opcjaz (get_tile "d1tg4") opcjaxy (get_tile "d1popup2"))
  (setq prec (nth (atoi (get_tile "d1popup")) '("0" "0.0" "0.00" "0.000" "0.0000")))
  (setq blok (nth (atoi (get_tile "d1popup3")) '("GeodPkt" "GeodPktEw" "GeodPik" "GeodOsn" "Own 1" "Own 2" "Own 3")))
  (done_dialog 1)
);defun reakcjad1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
; export punktw geodezyjnych
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Gstar8-geodexport ( / koniec dcl-id plik id nextnr ssbloki listaexp bloki-exp ob typz warn wz pos)
  (setq warn "" nextnr "1")
  (spr-globals)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (if (not (equal (getvar "UCSORG") '(0 0 0) 0.000001))
    (setq warn "\n- aktualny lokalny ukad wsprzednych ma poczatek w innym punkcie niz 0,0,0.")
  )
  (if (equal (trans '(0 0 1) 0 1 0) '(0 0 -1) 0.000001)
    (setq wz -1 warn (if (not (equal (getvar "UCSXDIR") '(0 1 0) 0.000001)) (strcat warn "\n- lokalny ukad wsprzednych jest obrcony wok osi OZ.") warn))
    (if (equal (trans '(0 0 1) 0 1 0) '(0 0 1) 0.000001)
      (setq wz 1 warn (if (not (equal (getvar "UCSXDIR") '(1 0 0) 0.000001)) (strcat warn "\n- lokalny ukad wsprzednych jest obrcony wok osi OZ.") warn))
      (alert+close+error "Bd! Aktualny ukad wsprzednych jest obrcony wok osi OX lub OY o kt inny niz 0g lub 200g." nil)
    )
  )
  (if (/= warn "")
    (alert (strcat "Ostrzezenie !" warn))
  )
  (setq g8geocad-export-ext "")
  (if *g8geocad-export* (if (setq pos (vl-string-position (ascii ".") *g8geocad-export* nil t))
    (if (> pos 0) (setq g8geocad-export-ext (substr *g8geocad-export* (+ pos 2))))))
  (if (setq plik (getfiled "G8GeoCad: Export Punktw" (if *g8geocad-export* *g8geocad-export* "") g8geocad-export-ext 1))
    (progn
      (setq *g8geocad-export* plik bloki-exp (ssadd))
      (setq dcl-id (load_dialog "Gstar8GeoExport.dcl"))  ;Load the dialog box.
      (if (< dcl-id 0)
        (alert+close+error "Bd przy probie otwarcia pliku Gstar8GeoExport.dcl" nil)
      )
      (while (not koniec)
        (if (null (new_dialog "export_dialog_1" dcl-id)) ;Initialize dialog
          (alert+close+error "Bd aktywacji okna \"export_dialog_1\"" nil)
        )
        (foreach % '("1" "2" "3" "4" "5" "6" "7" "8")
          (action_tile (strcat "d1b" %) (strcat "(done_dialog " (itoa (1+ (atoi %))) ")"))
        )
        (set_tile "d1t1" (itoa (length listaexp)))
        (set_tile "d1t2" (itoa (sslength bloki-exp)))
        (action_tile "accept" "(if (and (null listaexp) (= 0 (sslength bloki-exp))) (alert \"Nie wybrano blokw do exportu.\")(done_dialog 1))")
        (setq id (start_dialog) # -1)
        (cond
          ((= 1 id) (setq koniec 1))
          ((= 0 id) (setq koniec 0))
          ((= 2 id) ;dodaj przez wskazanie punktow
             (setq konieclp nil lista1 nil)
             (while (and (not konieclp) (setq p (getpoint "\nWska punkt >")))
               (new_dialog "export_dialog_2" dcl-id)
               (set_tile "d2t1" (strcat "wybrano: " (itoa (1+ (length lista1))) " pkt."))
               (set_tile "d2eb1" nextnr)
               (set_tile "d2eb2" (urtos (if (and (= wz 1) (= *g8geocad-xystyle* 1)) (cadr p) (car p)) 2 3))
               (set_tile "d2eb3" (urtos (if (and (= wz 1) (= *g8geocad-xystyle* 1)) (car p) (cadr p)) 2 3))
               (set_tile "d2eb4" (urtos (if (= wz 1) (* -1.0 *g8geocad-zstyle* (caddr p)) (caddr p)) 2 3))
               (action_tile "d2b1" "(if (exp-punkt-ok)(progn (setq nextnr (next-number (get_tile \"d2eb1\")) lista1 (cons (list \"p\"(get_tile \"d2eb1\")(atof(get_tile \"d2eb2\"))(atof(get_tile \"d2eb3\"))(atof(get_tile \"d2eb4\")))lista1) # (1+ #))(done_dialog 2)))")
               (action_tile "d2b2" "(done_dialog 3)")
               (action_tile "d2b3" "(progn (setq lista1 nil) (done_dialog 0))")
               (action_tile "d2b4" "(if (exp-punkt-ok)(progn (setq nextnr (next-number (get_tile \"d2eb1\")) lista1 (cons (list \"p\"(get_tile \"d2eb1\")(atof(get_tile \"d2eb2\"))(atof(get_tile \"d2eb3\"))(atof(get_tile \"d2eb4\")))lista1))(done_dialog 1)))")
               (setq id2 (start_dialog))
               (if (or (= id2 1) (= id2 0))
                 (setq konieclp 1)
               )
               (if (= id2 1) (setq listaexp (append lista1 listaexp)) )
             );while
          )
          ((= 3 id) ;dodaj przez wskazanie blokow
             (setq ss (ssget '((0 . "INSERT")(2 . "GeodPkt,GeodPktEw,GeodPik,GeodOsn"))))
             (if ss (while (setq ob (ssname ss (setq # (1+ #)))) (ssadd ob bloki-exp)));while & if
          )
          ((= 4 id)
             (setq ss (ssget "_X" '((0 . "INSERT")(2 . "GeodPkt"))))
             (if ss (while (setq ob (ssname ss (setq # (1+ #)))) (ssadd ob bloki-exp)));while & if
          )
          ((= 5 id)
             (setq ss (ssget "_X" '((0 . "INSERT")(2 . "GeodPktEw"))))
             (if ss (while (setq ob (ssname ss (setq # (1+ #)))) (ssadd ob bloki-exp)));while & if
          )
          ((= 6 id)
             (setq ss (ssget "_X" '((0 . "INSERT")(2 . "GeodOsn"))))
             (if ss (while (setq ob (ssname ss (setq # (1+ #)))) (ssadd ob bloki-exp)));while & if
          )
          ((= 7 id)
             (setq ss (ssget "_X" '((0 . "INSERT")(2 . "GeodPik"))))
             (if ss (while (setq ob (ssname ss (setq # (1+ #)))) (ssadd ob bloki-exp)));while & if
          )
          ((= 8 id)
             (setq ss (ssget "_X" '((0 . "INSERT")(2 . "GeodPkt,GeodPktEw,GeodPik,GeodOsn"))))
             (if ss (while (setq ob (ssname ss (setq # (1+ #)))) (ssadd ob bloki-exp)));while & if
          )
          ((= 9 id)
             (setq bloki-exp (ssadd))
             (setq listaexp nil)  
          )
        ) ; cond
      ) ; while
      (if (= koniec 1)
        (progn
          (new_dialog "export_dialog_3" dcl-id)
          (set_tile "d3t1" plik)
          (set_tile "d3popup1" "2")
          (if (= 0 (sslength bloki-exp))
            (mapcar '(lambda (%) (mode_tile % 1)) '("d3bc2" "d3eb2" "d3tg5" "d3tg6"))
          )
          (action_tile "d3tg2" "(if (and (= \"0\" (get_tile \"d3tg2\")) (= \"0\" (get_tile \"d3tg3\")) (= \"0\" (get_tile \"d3tg4\")))
                                  (progn (mode_tile \"d3popup1\" 1) (mode_tile \"d3bc1\" 1))
                                  (progn (mode_tile \"d3popup1\" 0) (mode_tile \"d3bc1\" 0)))")
          (action_tile "d3tg3" "(if (and (= \"0\" (get_tile \"d3tg2\")) (= \"0\" (get_tile \"d3tg3\")) (= \"0\" (get_tile \"d3tg4\"))) (mode_tile \"d3popup1\" 1) (mode_tile \"d3popup1\" 0))")
          (action_tile "d3tg4" "(if (and (= \"0\" (get_tile \"d3tg2\")) (= \"0\" (get_tile \"d3tg3\")) (= \"0\" (get_tile \"d3tg4\"))) (mode_tile \"d3popup1\" 1) (mode_tile \"d3popup1\" 0))")
          (action_tile "accept" "(Gstar8-export-ok)")
          (action_tile "d3popup2" "(Gstar8-export-reakcja-d3popup2 $value)")
          (start_dialog)
        )
      )
      (unload_dialog dcl-id)
    ) ; progn
  ) ; if
);defun Gstar8-geodexport

(defun Gstar8-export-reakcja-d3popup2 (item / #)
  (setq # (atoi item))
  (cond
    ((and (= # 0) (/= "" item))
       (mode_tile "d3tg5" 0)
       (mode_tile "d3tg6" 1)
    )
    ((= # 1)
       (mode_tile "d3tg5" 1)
       (mode_tile "d3tg6" 0)
    )
    ((= # 2)
       (mode_tile "d3tg5" 1)
       (mode_tile "d3tg6" 1)
    )
  );cond
);defun Gstar8-export-rakcja-d3popup2
       

  
(defun Gstar8-export-ok  ( / # valz valx valy valn tab typz f p obx oby obz obnr atr template isroi)
  (setq  valn (get_tile "d3tg1") valx (get_tile "d3tg2") valy (get_tile "d3tg3") valz (get_tile "d3tg4")
         prec (atoi (get_tile "d3popup1")) tab 12 typz (get_tile "d3popup2"))
  (cond
    ((and (= valn "0") (= valx "0") (= valy "0") (= valz "0"))
       (alert "Brak elementw do exportu.")
    )
    ((not (setq f (open plik "w")))
       (alert "Bad otwarcia pliku.\nOperacja exportu danych anulowana.")
       (done_dialog 1)
    )
    ((not nil)
       (if listaexp (setq listaexp (mapcar '(lambda(x) (list (car x)(cadr x)(urtos (caddr x) 2 prec)(urtos (cadddr x) 2 prec)(urtos (nth 4 x) 2 prec))) listaexp))
       )
       (setq # -1)
       (while (setq ob (ssname bloki-exp (setq # (1+ #))))
         (setq obnr (Gstar8-numer ob))
         (if (null obnr) (setq obnr " "))
         (setq p (trans (cdr (assoc 10 (entget ob))) ob 1)
               obx (if (= wz 1) (cadr p) (car p)) obx (urtos obx 2 prec)
               oby (if (= wz 1) (car p) (cadr p)) oby (urtos oby 2 prec))
         (cond
           ((= typz "2") ;0.0
              (setq obz (urtos 0.0 2 prec))
           )
           ((= typz "0") ;z
              (if (= "1" (get_tile "d3tg5"))
                (setq obz (abs (caddr p)))
                (setq obz (if (= wz 1) (* -1.0 *g8geocad-zstyle*(caddr p)) (caddr p)))
              )
              (setq obz (urtos obz 2 prec))
           )
           ((= typz "1") ;atrybut
              (setq atr (Gstar8-h ob))
              (if (null atr) (setq atr " "))
              (if (setq isroi (is-real-or-int atr))
                (setq atr (urtos (atof atr) 2 prec))
              )
              (if (and (= "1" (get_tile "d3tg6")) (not isroi))
                (setq atr (urtos 0.0 2 prec))
              )
              (setq obz atr)
           )
         );cond
         (setq listaexp (cons (list "b" obnr obx oby obz) listaexp))
       );while
       (setq template (vl-sort-i listaexp '(lambda (a b) (< (cadr a) (cadr b)))))
       (setq lista-out (mapcar '(lambda (%) (nth % listaexp )) template))
       (setq # 1 ## (length lista-out))
       (foreach % lista-out
         (if (and (= wz 1) (= *g8geocad-xystyle* -1) (= "b" (car %)))
           (setq % (list (car %) (cadr %) (cadddr %) (caddr %) (nth 4 %)))
         )
         (setq l "")
         (if (= "1" valn)
           (setq l (strcat (ciagspacji (- tab (strlen (cadr %)))) (cadr %))))
         (if (= "1" valx)
           (setq l (strcat l " " (strcat (ciagspacji (- tab (strlen (caddr %)))) (caddr %)))))
         (if (= "1" valy)
           (setq l (strcat l " " (strcat (ciagspacji (- tab (strlen (cadddr %)))) (cadddr %)))))
         (if (= "1" valz)
           (setq l (strcat l " " (strcat (ciagspacji (- tab (strlen (nth 4 %)))) (nth 4 %)))))
         (write-line l f)
         (if (= 0 (rem # 100))
           (set_tile "d3t2" (strcat "Wyeksportowano : " (itoa #) " / " (itoa ##) " punktw."))
         )
         (setq # (1+ #))
       )
       (close f)
       (alert (strcat "Zapisano " (itoa (length lista-out)) " punktw."))
       (done_dialog 1)
    );(not nil)
  );cond
);defun Gstar8-export-ok
       
        
(defun exp-punkt-ok ()
  (cond
    ((= (usun-spacje (get_tile "d2eb1")) "")
       (alert "Brak numeru punktu.")
    )
    ((not (is-real-or-int (get_tile "d2eb2")))
       (alert "Bedny format wsprzednej X.")
    )
    ((not (is-real-or-int (get_tile "d2eb2")))
       (alert "Bedny format wsprzednej X.")
    )
    ((not (is-real-or-int (get_tile "d2eb2")))
       (alert "Bedny format wsprzednej X.")
    )
    ((not nil)
       (not nil)
    )
  );cond
);defun exp-punkt-ok

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; makro wstawiajce tekst z opisem krzya kresek
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Gstar8-opiszkrzyz ( / p h styl)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (setq p (getpoint "\nWska rodek krzya :>"))
  (if p
    (progn
      (setq p (trans p 1 0))
      (setq h (cdr (assoc 40 (tblsearch "STYLE" (setq styl (getvar "TEXTSTYLE"))))))
      (if (= h 0.0)
        (setq h 1.5)
      )
      (entmake (list '(0 . "TEXT")'(100 . "AcDbEntity")'(100 . "AcDbText")(list 10 (+ (/ h 2.0)(car p)) (+ (/ h 2.0)(cadr p)) (caddr p))(cons 40 h)(cons 1 (rtos (cadr p) 2 0))'(50 . 0.0)(cons 7 styl)'(100 . "AcDbText")))
      (entmake (list '(0 . "TEXT")'(100 . "AcDbE  ntity")'(100 . "AcDbText")(list 10 (+ (/ h 2.0)(car p)) (- (cadr p)(/ h 2.0)) (caddr p))(cons 40 h)(cons 1 (rtos (car p) 2 0))(cons 50 (* 1.5 pi))(cons 7 styl)'(100 . "AcDbText")))
    )
  )
  (princ)
);defun Gstar8-opiszkrzyz

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; wstawia tekst z biecymi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Gstar8-biezace ( / a b prec wys strona dl dx/dl dy/dl ma na p xt yt n)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (if (setq a (getpoint "\nWska pierwszy punkt linii bazowej >"))
    (if (setq b (getpoint a "\nWska drugi punkt linii bazowej >"))
      (if (not (equal (list (car a)(cadr a)) (list (car b)(cadr b)) 0.00001))
        (progn
          (grdraw a b 4 1)
          (initget 5)
          (setq prec (getint "\nPodaj ilo miejsc po przecinku :"))
          (initget 7)
          (setq wys (getreal "\nPodaj wysoko tekstu :"))
          (initget 0 "Prawa Lewa")  
          (setq strona (getkword "\nPo ktrej stronie rysowa opisy [Prawa/Lewa]<Prawa> :"))
          (if (not strona) (setq strona "Prawa"))
          (if (not (tblsearch "STYLE" "GeodText"))
            (entmake '((0 . "STYLE")(100 . "AcDbSymbolTableRecord")(100 . "AcDbTextStyleTableRecord")(2 . "GeodText")(70 . 0)(40 . 0.0)(41 . 1.0)(50 . 0.25)(71 . 0)(42 . 2.5)(3 . "romans.shx")(4 . "")))
          )
          (setq a (trans a 1 0) b (trans b 1 0) )
          (setq dl (distance (list (car a)(cadr a)) (list (car b)(cadr b))) dx/dl (/ (- (car b) (car a)) dl)  dy/dl (/ (- (cadr b) (cadr a)) dl))
          (setq ma (+ (* dx/dl (car a)) (* dy/dl (cadr a))))
          (setq na (- (* dx/dl (cadr a)) (* dy/dl (car a))))
          (while (setq p (getpoint "\nWska punkt >"))
            (setq p (trans p 1 0))
            (setq m (- (+ (* dx/dl (car p)) (* dy/dl (cadr p))) ma))
            (setq n (- (- (* dx/dl (cadr p)) (* dy/dl (car p))) na))
            (if (= "Prawa" strona)
              (progn
                (setq n (/ wys -2.0))
                (setq xt (- (* dx/dl m) (* dy/dl n)) xt (+ xt (car a)))
                (setq yt (+ (* dy/dl m) (* dx/dl n)) yt (+ yt (cadr a)))
                (entmake (list '(0 . "TEXT")'(100 . "AcDbEntity")'(100 . "AcDbText")(list 10 xt yt 0.0)(list 11 xt yt 0.0)(cons 40 wys)(cons 1 (urtos m 2 prec))(cons 50 (- (angle a b)(/ pi 2.0)))(cons 7 "GeodText")'(72 . 0)'(100 . "AcDbText")'(73 . 2)))
              )
              (progn
                (setq n (/ wys 2.0))
                (setq xt (- (* dx/dl m) (* dy/dl n)) xt (+ xt (car a)))
                (setq yt (+ (* dy/dl m) (* dx/dl n)) yt (+ yt (cadr a)))
                (entmake (list '(0 . "TEXT")'(100 . "AcDbEntity")'(100 . "AcDbText")(list 10 xt yt 0.0)(list 11 xt yt 0.0)(cons 40 wys)(cons 1 (urtos m 2 prec))(cons 50 (- (angle a b)(/ pi 2.0)))(cons 7 "GeodText")'(72 . 2)'(100 . "AcDbText")'(73 . 2)))
              )             
            )
          )
        )
        (alert "Bad : wybrane punkty polozone s zbyt blisko siebie")
      );if
    );if
  );if
  (redraw)
  (princ)
);defun Gstar8-biezace

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; wstawia odnonik (leader) z opisem wsprzdnych wskazanego punktu
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Gstar8-leaderxy ( / p o t1 t2 ld ldlist ht prec st xy)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (setq wz (Gstar8-ucs-test))
  (if (setq p (getpoint "\nWska punkt >"))
    (if (setq o (getpoint "\nWska pooenie opisu >"))
      (progn
        (setq ht (vlax-ldata-get "LeaderXY" "wys-tekstu-str" nil (not nil)))
        (if (null ht) (setq ht 1.0))
        (if (= (type ht) 'STR) (setq ht (atof ht)))
        (setq prec (vlax-ldata-get "LeaderXY" "precyzja" nil (not nil)))
        (if (null prec) (setq prec 2))
        (if (= (type prec) 'STR) (setq prec (atoi prec)) (setq prec (fix prec)))
        (setq st (vlax-ldata-get "LeaderXY" "strzalka" nil (not nil)))
        (if (null st) (setq st 1))
        (if (= (type st) 'STR) (setq st (atoi st))(setq st (fix st)))
        (setq xy (vlax-ldata-get "LeaderXY" "zamianaxy" nil (not nil)))
        (if (null xy) (setq xy 1))
        (if (= (type xy) 'STR) (setq xy (atoi xy))(setq xy (fix xy)))
        (setq t1 (strcat "X=" (urtos (if (= wz 1) (if (= xy 1) (cadr p) (car p)) (car p)) 2 prec)) t2 (strcat "Y=" (urtos (if (= wz 1) (if (= xy 1) (car p) (cadr p)) (cadr p)) 2 prec)))
        (entmake (list '(0 . "LEADER")'(100 . "AcDbEntity")'(100 . "AcDbLeader")'(3 . "Standard")(if (= st 1) '(71 . 1) '(71 . 0))'(72 . 0)'(73 . 0)'(74 . 0)'(75 . 0)'(40 . 100.0)'(41 . 0.0)'(76 . 2)(cons 10 (trans p 1 0))(cons 10 (trans o 1 0))(list 210 0.0 0.0 1.0)))
        (setq ldlist (entget (setq ld (entlast))))
        (entmake (list '(0 . "MTEXT")'(102 . "{ACAD_REACTORS")(cons 330  ld)'(102 . "}")'(100 . "AcDbEntity")'(100 . "AcDbMText")(cons 10 (trans o 1 0))(cons 40 ht)'(41 . 0.0)'(50 . 0.0)'(71 . 7)'(72 . 5)(cons 1 (strcat t1 "\\P" t2))'(7 . "Standard")(cons 10 (trans o 1 0))'(73 . 1)'(44 . 0.8)(list 210 0.0 0.0 1.0)(list 11 1.0 0.0 0.0)))
        (entmod (subst (cons 340 (entlast)) (assoc 340 ldlist) ldlist))
        (entupd ld)
      )
    );if
  );if
);defun

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ustawia parametry wstawianego odnonika
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Gstar8-leaderxy-ustawienia ( / dcl-id %)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (setq dcl-id (load_dialog "Gstar8GeoOpcjeLeader.dcl"))  ;Load the dialog box.
  (if (< dcl-id 0)
    (progn
      (alert "Bd przy probie otwarcia pliku Gstar8GeoOpcjeLeader.dcl")
      (exit)
    )
  )
  (if (null (new_dialog "opcje_leader_dialog_1" dcl-id)) ;Initialize dialog
    (progn
      (alert "Bd aktywacji okna \"opcje_leader_dialog_1\"")
      (exit)
    )
  )
  (if (setq % (vlax-ldata-get "LeaderXY" "wys-tekstu-str" nil (not nil)))
    (set_tile "d1eb1" (if (= (type %) 'REAL) (urtos % 2 2) %))
    (set_tile "d1eb1" "1")
  )
  (if (setq % (vlax-ldata-get "LeaderXY" "precyzja" nil (not nil)))
    (set_tile "d1popup1" (if (= (type %) 'REAL) (urtos % 2 0) %))
    (set_tile "d1popup1" "2") 
  )
  (if (setq % (vlax-ldata-get "LeaderXY" "strzalka" nil (not nil)))
    (set_tile "d1tg1" (if (= (type %) 'REAL) (urtos % 2 0) %))
    (set_tile "d1tg1" "1")
  )
  (if (setq % (vlax-ldata-get "LeaderXY" "zamianaxy" nil (not nil)))
    (set_tile "d1tg2" (if (= (type %) 'REAL) (urtos % 2 0) %))
    (set_tile "d1tg2" "1")
  )
  (action_tile "accept" "(Gstar8-leaderxy-ust-ok)")
  (start_dialog)
) 

(defun Gstar8-leaderxy-ust-ok ( / wys )
  (if (is-real-or-int (setq wys (get_tile "d1eb1")))
    (progn
      (if (> (atof wys) 0.0)
        (progn
          (vlax-ldata-put "LeaderXY" "wys-tekstu-str" wys (not nil)) 
          (vlax-ldata-put "LeaderXY" "precyzja" (get_tile "d1popup1") (not nil))
          (vlax-ldata-put "LeaderXY" "strzalka" (get_tile "d1tg1") (not nil))
          (vlax-ldata-put "LeaderXY" "zamianaxy" (get_tile "d1tg2") (not nil))
          (done_dialog 1)
        )
        (alert "Wysokosc tekstu musi byc wieksza od zera.")
      )
    )
    (alert "Bad : Niepoprawna wysokosc tekstu.")
  )
);defun Gstar8-leaderxy-ust-ok

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ustawia parametry wstawianych blokw
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Gstar8-ustawienia ( / dcl-id x)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (command "_UNDO" "_M")
  (setq dcl-id (load_dialog "Gstar8GeoOpcje.dcl"))
  (if (< dcl-id 0)(progn (alert "Bd przy probie otwarcia pliku Gstar8GeoOpcje.dcl")(exit)))
  (if (null (new_dialog "opcje_dialog_1" dcl-id))(progn (alert "Bd aktywacji okna \"opcje_dialog_1\"")(exit)))  
  (start_image "d1im1")
  (slide_image 0 0 (dimx_tile "d1im1") (dimy_tile "d1im1") "gstar8-pkt")
  (end_image)
  (start_image "d1im2")
  (slide_image 0 0 (dimx_tile "d1im2") (dimy_tile "d1im2") "gstar8-pktew")
  (end_image)
  (start_image "d1im3")
  (slide_image 0 0 (dimx_tile "d1im3") (dimy_tile "d1im3") "gstar8-osn")
  (end_image)
  (start_image "d1im4")
  (slide_image 0 0 (dimx_tile "d1im4") (dimy_tile "d1im4") "gstar8-pik")
  (end_image)
  (setq x (vlax-ldata-get "Gstar8GeodPkt" "skala" nil (not nil)) x (if (null x) "1" x))
  (set_tile "d1eb1" (if (= (type x) 'REAL) (rtos x 2 2) x))
  (setq x (vlax-ldata-get "Gstar8GeodPktEw" "skala" nil (not nil)) x (if (null x) "1" x))
  (set_tile "d1eb2" (if (= (type x) 'REAL) (rtos x 2 2) x))
  (setq x (vlax-ldata-get "Gstar8GeodOsn" "skala" nil (not nil)) x (if (null x) "1" x))
  (set_tile "d1eb3" (if (= (type x) 'REAL) (rtos x 2 2) x))
  (setq x (vlax-ldata-get "Gstar8GeodPik" "skala" nil (not nil)) x (if (null x) "1" x))
  (set_tile "d1eb4" (if (= (type x) 'REAL) (rtos x 2 2) x))
  (setq x (vlax-ldata-get "Gstar8GeodPkt" "nazwa" nil (not nil)) x (if (null x) "1" x))
  (set_tile "d1tg1a" (if (= (type x) 'REAL) (rtos x 2 0) x))
  (setq x (vlax-ldata-get "Gstar8GeodPkt" "blok" nil (not nil)) x (if (null x) "1" x))
  (set_tile "d1tg1b" (if (= (type x) 'REAL) (rtos x 2 0) x))
  (setq x (vlax-ldata-get "Gstar8GeodPktEw" "nazwa" nil (not nil)) x (if (null x) "1" x))
  (set_tile "d1tg2a" (if (= (type x) 'REAL) (rtos x 2 0) x))
  (setq x (vlax-ldata-get "Gstar8GeodPktEw" "blok" nil (not nil)) x (if (null x) "1" x))
  (set_tile "d1tg2b" (if (= (type x) 'REAL) (rtos x 2 0) x))
  (setq x (vlax-ldata-get "Gstar8GeodOsn" "nazwa" nil (not nil)) x (if (null x) "1" x))
  (set_tile "d1tg3a" (if (= (type x) 'REAL) (rtos x 2 0) x))
  (setq x (vlax-ldata-get "Gstar8GeodOsn" "blok" nil (not nil)) x (if (null x) "1" x))
  (set_tile "d1tg3b" (if (= (type x) 'REAL) (rtos x 2 0) x))
  (setq x (vlax-ldata-get "Gstar8GeodPik" "nazwa" nil (not nil)) x (if (null x) "1" x))
  (set_tile "d1tg4a" (if (= (type x) 'REAL) (rtos x 2 0) x))
  (setq x (vlax-ldata-get "Gstar8GeodPik" "blokh" nil (not nil)) x (if (null x) "1" x))
  (set_tile "d1tg4b" (if (= (type x) 'REAL) (rtos x 2 0) x))
  (setq x (vlax-ldata-get "Gstar8GeodPik" "blok" nil (not nil)) x (if (null x) "1" x))
  (set_tile "d1tg4c" (if (= (type x) 'REAL) (rtos x 2 0) x))
  (action_tile "d1b1" "(Gstar8-ust-zastosuj)")
  (start_dialog)
  (unload_dialog dcl-id)
);defun Gstar8-ustawienia

(defun Gstar8-ust-zastosuj ( / sk1 sk2 sk3 sk4 x)
  (cond ((not (is-real-or-int (setq sk1 (usun-spacje (get_tile "d1eb1")))))
           (alert "Bad : Niepoprawna skala dla bloku \"GeodPkt\".")
        )
        ((<= (atof sk1) 0.0)
           (alert "Bad : Skala \"GeodPkt\" musi byc wieksza od 0.")
        )
        ((not (is-real-or-int (setq sk2 (usun-spacje (get_tile "d1eb2")))))
           (alert "Bad : Niepoprawna skala dla bloku \"GeodPktEw\".")
        )
        ((<= (atof sk2) 0.0)
           (alert "Bad : Skala \"GeodPktEw\" musi byc wieksza od 0.")
        )
        ((not (is-real-or-int (setq sk3 (usun-spacje (get_tile "d1eb3")))))
           (alert "Bad : Niepoprawna skala dla bloku \"GeodOsn\".")
        )
        ((<= (atof sk3) 0.0)
           (alert "Bad : Skala \"GeodOsn\" musi byc wieksza od 0.")
        )
        ((not (is-real-or-int (setq sk4 (usun-spacje (get_tile "d1eb4")))))
           (alert "Bad : Niepoprawna skala dla bloku \"GeodPik\".")
        )
        ((<= (atof sk4) 0.0)
           (alert "Bad : Skala \"GeodPik\" musi byc wieksza od 0.")
        )
        ((not nil)
           (vlax-ldata-put "Gstar8GeodPkt" "skala" sk1 (not nil))
           (Gstar8-korekta-skali "GeodPkt" (atof sk1))
           (vlax-ldata-put "Gstar8GeodPktEw" "skala" sk2 (not nil))
           (Gstar8-korekta-skali "GeodPktEw" (atof sk2))
           (vlax-ldata-put "Gstar8GeodOsn" "skala" sk3 (not nil))
           (Gstar8-korekta-skali "GeodOsn" (atof sk3))
           (vlax-ldata-put "Gstar8GeodPik" "skala" sk4 (not nil))
           (Gstar8-korekta-skali "GeodPik" (atof sk4))
;;;           (vlax-ldata-put "Gstar8GeodPkt" "blok" (setq x (get_tile "d1tg1b")) (not nil))
;;;           (Gstar8-korekta-wb "GeodPkt" (- 1 (atoi x))) 
           (vlax-ldata-put "Gstar8GeodPkt" "nazwa" (setq x (get_tile "d1tg1a")) (not nil))
           (Gstar8-korekta-wn "GeodPkt" (- 1 (atoi x)))
;;;           (vlax-ldata-put "Gstar8GeodPktEw" "blok" (setq x (get_tile "d1tg2b")) (not nil))
;;;           (Gstar8-korekta-wb "GeodPktEw" (- 1 (atoi x)))
           (vlax-ldata-put "Gstar8GeodPktEw" "nazwa" (setq x (get_tile "d1tg2a")) (not nil))
           (Gstar8-korekta-wn "GeodPktEw" (- 1 (atoi x)))
;;;           (vlax-ldata-put "Gstar8GeodOsn" "blok" (setq x (get_tile "d1tg3b")) (not nil))
;;;           (Gstar8-korekta-wb "GeodOsn" (- 1 (atoi x)))
           (vlax-ldata-put "Gstar8GeodOsn" "nazwa" (setq x (get_tile "d1tg3a")) (not nil))
           (Gstar8-korekta-wn "GeodOsn" (- 1 (atoi x)))
;;;           (vlax-ldata-put "Gstar8GeodPik" "blok" (setq x (get_tile "d1tg4c")) (not nil))
;;;           (Gstar8-korekta-wb "GeodPik" (- 1 (atoi x)))
           (vlax-ldata-put "Gstar8GeodPik" "blokh" (setq x (get_tile "d1tg4b")) (not nil))
           (Gstar8-korekta-wh "GeodPik" (- 1 (atoi x)))
           (vlax-ldata-put "Gstar8GeodPik" "nazwa" (setq x (get_tile "d1tg4a")) (not nil))
           (Gstar8-korekta-wn "GeodPik" (- 1 (atoi x)))
           (done_dialog 1)
        )
  );cond     
);defun Gstar8-ust-zastosuj

(defun Gstar8-korekta-wb (blok kod60 / ob obl) ;korekta widocznoci blokw  poprzez zmiane definicji 
  (Gstar8-insert-preview blok)
  (setq ob (cdr (assoc -2 (tblsearch "BLOCK" blok))))
  (while ob
    (if (/= "ATTDEF" (cdr (assoc 0 (setq obl (entget ob)))))
      (if (assoc 60 obl)
        (entmod (subst (cons 60 kod60) (assoc 60 obl) obl))
        (if (= kod60 1) (entmod (append obl '((60 . 1)))))
      )
    )
    (setq ob (entnext ob))
  );while
);defun Gstar8-korekta-wb

(defun Gstar8-korekta-wn (blok kod60 / ob n ss obn) ;korekta widocznoci atrybutu "Nazwa"
  (setq ss (ssget "_X" (list '(0 . "INSERT")(cons 2 blok))) n -1)
  (if ss
    (while (setq ob (ssname ss (setq n (1+ n))))
      (if (Gstar8-numer ob)
        (progn
          (setq obn (entget (entnext ob)))
          (if (assoc 60 obn)
            (entmod (subst (cons 60 kod60) (assoc 60 obn) obn))
            (if (= kod60 1) (entmod (append obn '((60 . 1)))))
          )
          (entupd ob)
        );progn
      );if
      (if (zerop (rem n 100))
        (if (> n 0) (set_tile "d1t1" (strcat "zmodyfikowano " blok " : " (itoa n))))) 
    );while
  );if
);defun Gstar8-korekta-wn

(defun Gstar8-korekta-wh (blok kod60 / ob n ss obn) ;korekta widocznoci atrybutu "H"
  (setq ss (ssget "_X" (list '(0 . "INSERT")(cons 2 blok))) n -1)
  (if ss
    (while (setq ob (ssname ss (setq n (1+ n))))
      (if (Gstar8-numer ob)
        (progn
          (setq obn (entget (entnext (entnext ob))))
          (if (assoc 60 obn)
            (entmod (subst (cons 60 kod60) (assoc 60 obn) obn))
            (if (= kod60 1) (entmod (append obn '((60 . 1)))))
          )
          (entupd ob)
        );progn
      );if
      (if (zerop (rem n 100))
        (if (> n 0) (set_tile "d1t1" (strcat "zmodyfikowano " blok " : " (itoa n))))) 
    );while
  );if
);defun Gstar8-korekta-wn

(defun Gstar8-korekta-skali (blok sk / ob ss n p obl atr1l atr2l) ;korekta skali blokw
  (setq ss (ssget "_X" (list '(0 . "INSERT")(cons 2 blok))) n -1)
  (if ss
    (while (setq ob (ssname ss (setq n (1+ n)))) 
      (if (not (= 4 (logand 4 (cdr (assoc 70 (tblsearch "layer" (cdr (assoc 8 (entget ob)))))))))
        (progn
          (setq obl (entget ob) p (cdr (assoc 10 (entget ob))))
          (setq obl (subst (cons 41 sk) (assoc 41 obl) obl))
          (setq obl (subst (cons 42 sk) (assoc 42 obl) obl))
          (setq obl (subst (cons 43 sk) (assoc 43 obl) obl))
          (entmod obl)
          (if (Gstar8-numer ob)
            (progn
              (setq atr1l (entget (entnext ob)))
              (if (= "GeodPik" blok)
                (setq atr1l (subst (cons 10 (list (+ (car p) (* sk *g8geocad-dx*)) (- (cadr p) (* sk *g8geocad-dy*)) (caddr p))) (assoc 10 atr1l) atr1l))
                (setq atr1l (subst (cons 10 (list (+ (car p) (* sk *g8geocad-dx*)) (+ (cadr p) (* sk *g8geocad-dy*)) (caddr p))) (assoc 10 atr1l) atr1l))
              )
              (setq atr1l (subst (cons 40 (* sk *g8geocad-hname*)) (assoc 40 atr1l) atr1l))
              (entmod atr1l)
            );progn
          );if
          (if (Gstar8-h ob)
            (progn
              (setq atr2l (entget (entnext (entnext ob))))
              (if (= "GeodPik" blok)
                (setq atr2l (subst (cons 10 (list (+ (car p) (* sk *g8geocad-dx*)) (+ (cadr p) (* sk *g8geocad-dy*)) (caddr p))) (assoc 10 atr2l) atr2l))
                (setq atr2l (subst (cons 10 (list (+ (car p) (* sk *g8geocad-dx*)) (- (cadr p) (* sk *g8geocad-dy*)) (caddr p))) (assoc 10 atr2l) atr2l))
              )
              (setq atr2l (subst (cons 40 (* sk *g8geocad-hname*)) (assoc 40 atr2l) atr2l))
              (entmod atr2l)
            );progn
          );if
          (entupd ob)
        );progn
      );if
      (if (zerop (rem n 100))
        (if (> n 0) (set_tile "d1t1" (strcat "zmodyfikowano " blok " : " (itoa n)))))
    );while
  );if
);defun Gstar8-korekta-skali

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; makro rysujce linie pomidzy wskazanymi blokami
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
             
(defun Gstar8-wstaw-z-listy2 ( / ss dcl-id koniec # ob list1 list2 hndl nr p1 p2 poz)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (setq ss (ssget "_X" '((0 . "INSERT")(2 . "GeodPkt,GeodPktEw,GeodOsn,GeodPik"))))
  (cond
    ((not ss)
     (alert "Nie ma blokw aplikacji G8GeoCad w rysunku.")
    )
    ((< (setq dcl-id (load_dialog "Gstar8GeoLista2.dcl")) 0)
     (alert+close+error "Bd przy prbie otwarcia pliku Gstar8GeoLista2.dcl" nil)
    )
    ((not nil)
     (setq # -1)
     (while (setq ob (ssname ss (setq # (1+ #))))
       (setq hndl (cdr (assoc 5 (entget ob))))
       (setq nr (Gstar8-numer ob))
       (if (not nr) (setq nr " "))
       (setq list1 (cons (cons nr hndl) list1) list2 (cons (cons (strcase nr) hndl) list2))
     );while
     (setq koniec nil)
     (while (not koniec)
       (if (null (new_dialog "lista2_dialog_1" dcl-id "" (if poz poz '(-1 -1))))
         (alert+close+error "Bd aktywacji okna \"lista2_dialog_1\"" nil)
       )
       (set_tile "d1eb1" *g8geocad-nrpocz*)
       (set_tile "d1eb2" (next-number *g8geocad-nrpocz*))
       (set_tile "d1tg1" *g8geocad-uwl*)
       (action_tile "d1b1" "(progn (setq *g8geocad-uwl* (get_tile \"d1tg1\")) (done_dialog 0))")
       (action_tile "d1b2" "(wstaw-z-listy2-rysuj)")
       (if (null (setq koniec (= 0 (start_dialog))))
         (command "_.LINE" "_non" p1 "_non" p2 "")
       ) 
     );while
     (unload_dialog dcl-id)
    )
  );cond
  (princ)
);defun Gstar8-wstaw-z-listy2

(defun wstaw-z-listy2-rysuj ( / box1 box2 %)
  (setq box1 (get_tile "d1eb1") box2 (get_tile "d1eb2") *g8geocad-uwl* (get_tile "d1tg1"))
  (cond
    ((= "" (usun-spacje box1))
     (alert "Brak punktu pocztkowego.")
    )
    ((= "" (usun-spacje box2))
     (alert "Brak punktu koncowego.")
    )
    ((and (= "1" *g8geocad-uwl*) (not (assoc box1 list1)))
     (alert (strcat "Nie znaleziono punktu " box1 " w rysunku.\nSprbuj odznaczyc opcje uwzgledniania wielkosci liter."))
    )
    ((and (= "0" *g8geocad-uwl*) (not (assoc (strcase box1) list2)))
     (alert (strcat "Nie znaleziono punktu " box1 " w rysunku."))
    )
    ((and (= "1" *g8geocad-uwl*) (not (assoc box2 list1)))
     (alert (strcat "Nie znaleziono punktu " box2 " w rysunku.\nSprbuj odznaczyc opcje uwzgledniania wielkosci liter."))
    )
    ((and (= "0" *g8geocad-uwl*) (not (assoc (strcase box2) list2)))
     (alert (strcat "Nie znaleziono punktu " box2 " w rysunku."))
    )
    ((= box1 box2)
     (alert "Bd! Punkty poczatkowy i koncowy s takie same.")
    )
    ((= *g8geocad-uwl* "0")
     (if (setq % (assoc box1 list1))
       (setq p1 (cdr (assoc 10 (entget (handent (cdr %))))) p1 (trans p1 (handent (cdr %)) 1))
       (setq p1 (cdr (assoc 10 (entget (handent (cdr (assoc (strcase box1) list2)))))) p1 (trans p1 (handent (cdr (assoc (strcase box1) list2))) 1))
     )
     (if (setq % (assoc box2 list1))
       (setq p2 (cdr (assoc 10 (entget (handent (cdr %))))) p2 (trans p2 (handent (cdr %)) 1))
       (setq p2 (cdr (assoc 10 (entget (handent (cdr (assoc (strcase box2) list2)))))) p2 (trans p2 (handent (cdr (assoc (strcase box2) list2))) 1))
     )
     (setq *g8geocad-nrpocz* box2)
     (setq poz (done_dialog 1))
    )
    ((= *g8geocad-uwl* "1")
     (setq % (assoc box1 list1))
     (setq p1 (cdr (assoc 10 (entget (handent (cdr %))))) p1 (trans p1 (handent (cdr %)) 1))
     (setq % (assoc box2 list1))
     (setq p2 (cdr (assoc 10 (entget (handent (cdr %))))) p2 (trans p2 (handent (cdr %)) 1))
     (setq *g8geocad-nrpocz* box2)
     (setq poz (done_dialog 1))
    )
  );cond
);defun wstaw-z-listy2-rysuj

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; makro transforujce uklad wsprzdnych poprzez dwa punkty dostosowania
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        
(defun geod-transformacja ( / ucs p1 p2 q1 q2 dxp dyp dxw dyw m u v r wsp)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (if (or (not ( = (getvar "UCSNAME") "Geod")) (not (equal (getvar "UCSORG") '(0 0 0) 0.000001)) )
    (progn
      (Gstar8-geoducs)
      (alert "Ustawiono geodezyjny ukad wsprzednych")
    )
  )
  (cond
    ((null (setq p1 (getpoint "\nWska pierwszy punkt >")))
     (prompt "\nNie wskazano punktu - transformacja anulowana.")
    )
    ((null (setq q1 (getpoint "\nPodaj jego wsprzdne w nowym ukadzie <x,y> :")))
     (prompt "\nNie podano wsprzednych - transformacja anulowana.")
    )
    ((null (setq p2 (getpoint "\nWska drugi punkt >")))
     (prompt "\nNie wskazano punktu - transformacja anulowana.")
    )
    ((null (setq q2 (getpoint "\nPodaj jego wsprzdne w nowym ukladzie <x,y> :")))
     (prompt "\nNie podano wsprzednych - transformacja anulowana.")
    )
    ((not nil)
     (setq ucs (getstring "\nPodaj nazw nowego ukladu wsprzednych (UCS) :"))
     (setq dxp (- (car p2) (car p1)) dyp (- (cadr p2) (cadr p1)) dxw (- (car q2) (car q1)) dyw (- (cadr q2) (cadr q1)))
     (setq m (+ (* dxp dxp) (* dyp dyp)))
     (setq u (/ (- (* dxp dyw)(* dyp dxw)) m))
     (setq v (/ (+ (* dxp dxw)(* dyp dyw)) m))
     (setq r (/ (distance (list (car p1) (cadr p1)) (list (car p2) (cadr p2))) (distance (list (car q1)(cadr q1)) (list (car q2) (cadr q2)))))
     (setq wsp '(lambda (p / x y xw yw #)
               (setq x (car p) y (cadr p) # (+ (* u u) (* v v)))               
               (setq yw (+ (cadr p1)(/ (+ (* y v) (* -1.0 (cadr q1) v) (* -1.0 x u) (* (car q1) u)) # )))
               (setq xw (+ (car p1) (/ (+ (* y u) (* -1.0 (cadr q1) u) (* -1.0 (car q1) v) (* x v)) #)))
               (list xw yw 0.0) 
             );lambda
     );setq
     (alert (strcat "\nu=" (urtos u 2 6) " , v=" (urtos v 2 6) " , r=" (urtos r 2 6)))
     (command "_UCS" "_new" "_3" "_non" ((eval wsp) '(0 0)) "_non" ((eval wsp) '(1000 0)) "_non" ((eval wsp) '(0 1000)))
     (if (tblsearch "UCS" ucs)
       (command "_UCS" "_save" ucs "_yes" )
       (command "_UCS" "_save" ucs)
     )
    );(not nil)
  );cond
  (princ)
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Modyfikacja polilinii do zadanej powierzchni poprzez zmian jednego boku (odsunicie rwnolege)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Gstar8-proj-pow ( / ob ob2 koniec listap listab ilp flaga % # ob# p1 p2 pd ans ang a b c d at bt na nb nc nd iter listap2 fuzz npl kier skok h linetemp)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (cond
    ((not (setq ob (car (entsel "\nWskaz polilinie >"))))
       (prompt "\nNie wskazano obiektu.")
    )
    ((/= (cdr (assoc 0 (entget ob))) "LWPOLYLINE")
       (prompt "\nWskazany obiekt nie jest polilinia.")
    )
    ((progn
       (setq listap (listaent 10 (entget ob)) listab (listaent 42 (entget ob)))
       (setq ilp (length listap))
       (< ilp 3)
     )
       (prompt "\nWybrana polilinia ma za mao segmentw.")
    )
    ((progn
       (setq flaga nil) ; flaga = "polilinia ma elementy lukowe"
       (foreach % listab
         (if (not (equal % 0.0 0.000001))
           (progn
            (print %)
           (setq flaga (not nil))
           )
         )
       )
       flaga
     )
       (prompt "\nPolilinia nie moze miec segmentw ukowych.")
    )
    ((progn
       (if (equal (car listap) (last listap))
         (setq listap (reverse (cdr (reverse listap))) ilp (1- ilp))
       )
       (setq flaga nil # 0) ; flaga = "polilinia ma segmenty zerowe"
       (while (<= (setq # (1+ #)) ilp)
         (if (< (distance (nth (- # 1) listap) (nth (if (= # ilp) 0 #) listap)) 0.00001)
           (setq flaga (not nil))
         )
       )
       flaga
     )
       (prompt "\nPolilinia nie moze miec segmentow zerowej dlugosci.")
    )
    ((= 4 (logand 4 (cdr (assoc 70 (tblsearch "layer" (cdr (assoc 8 (entget ob))))))))
     (prompt "\nPolilinia nie moze byc na warstwie zablokowanej")
    )
    ((= 4 (logand 4 (cdr (assoc 70 (tblsearch "layer" (getvar "CLAYER"))))))
     (prompt "\nAktualna warstwa nie moze byc zablokowana")
    )
    ((not nil)
       (setq ob# (setq ob# (vlax-ename->vla-object ob)))
       (setq p1 (vla-get-area ob#))
       (initget 7)
       (setq pd (getreal (strcat "\nPodaj powierzchnie docelowa (polilinia = " (urtos p1 2 2) ") :")))
       (setq # 1 koniec nil)
       (while (not koniec)
         (command "_line" "_non" (trans (nth (- # 1) listap) ob 1) "_non" (if (= # ilp) (trans (nth 0 listap) ob 1) (trans (nth # listap) ob 1)) "")
         (command "_chprop" (entlast) "" "_color" "3" "")
         (setq linetemp (entlast))
         (initget 0 "Nastepna Ok Anuluj")
         (setq ans (getkword "\nWskaz linie bazowa [Nastepna/Ok/Anuluj] <Nastepna> :"))
         (if (null ans)
           (setq ans "Nastepna")
         )
         (if (= ans "Nastepna")
           (setq # (if (= # ilp) 1 (1+ #)))
           (setq koniec (not nil))
         )
         (entdel linetemp)
       );while
       (if (= ans "Anuluj")
         (alert "Makro anulowano")
         (progn
       (setq c (nth (if (= # 1) (progn (setq nc ilp)(- ilp 1))(progn (setq nc (- # 1))(- # 2))) listap)
             a (nth (progn (setq na #)(- # 1)) listap)
             b (nth (if (= # ilp) (progn (setq nb 1) 0) (progn (setq nb (+ 1 #)) #)) listap)
             d (if (= # ilp)
                 (nth (progn (setq nd 2) 1) listap)
                 (if (= # (- ilp 1))
                   (nth (progn (setq nd 1) 0) listap)
                   (nth (progn (setq nd (+ 2 #))(+ 1 #)) listap)))
       );setq
       (if (or (equal (* (-(cadr a)(cadr c)) (-(car b)(car a))) (* (-(car a)(car c)) (-(cadr b)(cadr a))) 0.00001)
               (equal (* (-(cadr b)(cadr a)) (-(car d)(car b))) (* (-(car b)(car a)) (-(cadr d)(cadr b))) 0.00001))
         (alert "Bd! Zaden segment przylegy do wybranego nie moze byc z nim wspliniowy.")
         (progn
           (setq ang (angle (trans a ob 1) (trans b ob 1)) ang (+ ang (/ pi 2.0)) kier 1.0)
           (setq iter 1 koniec nil fuzz 0.00001 h (/ (/ (abs (- pd p1)) (distance a b)) 10) skok h)
           (while (not koniec)
             (setq at (polar (trans a ob 1) ang h) bt (polar (trans b ob 1) ang h))
             (setq a2 (inters (trans a ob 1) (trans c ob 1) at bt nil) b2 (inters (trans b ob 1) (trans d ob 1) at bt nil))
             (setq # 1 listap2 nil)
             (while (<= # ilp)
               (cond ((= # na) (setq listap2 (cons (trans a2 1 ob) listap2)))
                     ((= # nb) (setq listap2 (cons (trans b2 1 ob) listap2)))
                     ((not nil) (setq listap2 (cons (nth (- # 1) listap) listap2)))
               )
               (setq # (1+ #))
             )
             (if (and ob2 (entget ob2)) (entdel ob2))
             (entmake (setq npl (append (list '(0 . "LWPOLYLINE")'(100 . "AcDbEntity") '(100 . "AcDbPolyline")'(70 . 1) '(60 . 1) '(62 . 4)
                                              (cons 90 ilp)(assoc 210 (entget ob)))
                                        (mapcar '(lambda (x) (cons 10 x)) listap2) )))
             (setq ob2 (entlast))
             (setq iter (1+ iter))
             (setq p2 (vla-get-area (vlax-ename->vla-object ob2)))
             (if (and (not (> p1 p2 pd)) (not (> pd p2 p1)))
               (setq skok (/ skok 2.0) kier (* kier -1))
             )
             (if (< kier 0)
               (setq h (- h skok))
               (setq h (+ h skok))
             )
             (if (equal p2 pd fuzz)
               (setq koniec 1)
             )
             (if (> iter 1000)
               (setq koniec 2)
             )
             (setq p1 p2)
           );while
           (if (= koniec 1)
             (progn
               (entmod (subst '(60 . 0) '(60 . 1) (entget ob2)))
               (setq # (cdr (assoc 70 (entget ob2))))
               (if (or (= 0 #) (= 128 #))
                 (entmod (subst (cons 70 (1+ #)) (cons 70 #) (entget ob2)))
               )
               (entmod (append (entget ob) '((60 . 1))))
               (command "_MATCHPROP" ob ob2)
               (command)
               (entdel ob)
               (entmod (subst '(60 . 0) '(60 . 1) (entget ob2)))
               (prompt (strcat "\nPowierzchnia = " (urtos pd 2 4) ". Wykonano " (itoa iter) " iteracji."))
             )
             (alert "Operacja nie udaa sie.Sprbuj podac docelowa powierzchnie blizsza obecnej.")
           );if
         );progn
       );if
       )
     )
     );(not nil)
  );cond
  (redraw)
  (princ)
);defun Gstar8-proj-pow

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Makro drukujce odlego midzy punktami i sum odlegoci
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun c:Gstar8-odleglosc ( / sumarz sumazr p1 p2 odlrz odlzr)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (setq sumarz 0.0 sumazr 0.0)
  (while (and (setq p1 (getpoint "\nWska pierwszy punkt >")) (setq p2 (getpoint p1 "Wska drugi punkt >")))
    (setq odlrz (distance p1 p2) odlzr (distance (list (car p1) (cadr p1)) (list (car p2) (cadr p2))))
    (prompt (strcat "\ndl.zredukowana: "
                    (urtos odlzr 2 4)
                    (if (equal odlzr odlrz 0.0001) " (-) " (strcat " (3D = " (urtos odlrz 2 4) ") "))
                    ", suma: "
                    (urtos (setq sumazr (+ sumazr odlzr)) 2 4)
                    (if (equal sumazr (setq sumarz (+ sumarz odlrz)) 0.0001) " (-) " (strcat " (3D = " (urtos sumarz 2 4) ") "))
            )
    )
  );while
);defun Gstar8-odleglosc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Makro wyswietlajce informacje o aplikacji
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun Gstar8-info ()
  (alert "Zestaw makr geodezyjnych do programu GstarCad2015.\nWersja 1.00 (2013.11.06)\nDystrybucja : MT Partner s.c. www.gstarcad.pl")
  (princ)
)

(setq *oglp-fuzz* 0.002)
(setq *oglp-dokl* 2)


;==================================================================================================================================================

(defun oglp-ssss (pt ht / odlmin lhmin m dl xmin xmax ymin ymax x y n ob h lp lodl dlob % lhmin2 pt2)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (setq odlmin 1.0e30 lhmin nil)
  (setq pt (list (car pt) (cadr pt)))
  (foreach h *oglp-lh*
    (setq m (assoc h *oglp-ldl*))
    (setq dl (cadr m))
    (setq xmin (nth 2 m))
    (setq xmax (nth 3 m))   
    (setq x (car pt))
    (if (and (> (+ x odlmin) xmin) (< (- x odlmin) xmax))
      (progn
        (setq ymin (nth 4 m))
        (setq ymax (nth 5 m))
        (setq y (cadr pt))
        (if (and (> (+ y odlmin) ymin) (< (- y odlmin) ymax))
          (progn
            (setq ob (handent h))
            (setq lp (vl-remove nil (mapcar '(lambda (%) (if (or (= (car %) 10) (= (car %) 11)) (trans (cdr %) ob 1) nil)) (entget ob))))
            (setq lodl (mapcar '(lambda (%) (distance % pt)) lp))
            (setq dlob (apply 'min lodl))
            (if (equal dlob odlmin 0.00001)
              (setq lhmin (cons (cons h dl) lhmin))
              (if (< dlob odlmin)
                (setq odlmin dlob lhmin (list (cons h dl)))
              );if
            );if
          );progn
        );if
      );progn
    );if   
  );foreach
  (setq lhmin (mapcar '(lambda (%) (nth % lhmin)) (vl-sort-i lhmin '(lambda (x y) (< (cdr x) (cdr y))))))
  (foreach % lhmin
    (setq pt2 (oglp-numeruj (handent (car %)) pt ht))
  )
  (setq lhmin2 (mapcar '(lambda (%) (car %)) lhmin))
  (setq *oglp-lh* (vl-remove-if '(lambda (%) (member % lhmin2)) *oglp-lh*))
  (if (> (length *oglp-lh*) 0) (oglp-ssss pt2 ht))
);defun

(defun oglp-numeruj (ob pt ht / # lp n minimum p odl poz lp1 lp2)
  (setq pt (list (car pt) (cadr pt)))
  (setq lp (vl-remove nil (mapcar '(lambda (%) (if (or (= (car %) 10) (= (car %) 11)) (trans (cdr %) ob 1) nil)) (entget ob))))
  (setq n 0 minimum 1.0e30)
  (while (setq p (nth n lp))
    (setq odl (distance p pt))
    (if (< odl minimum)
      (setq minimum odl poz n)
    )
    (setq n (1+ n))
  );while
  (setq # 0 lp1 nil lp2 nil)
  (while (< # poz)
    (setq lp1 (cons (nth # lp) lp1))
    (setq # (1+ #))
  )
  (setq # poz)
  (while (< # (length lp))
    (setq lp2 (cons (nth # lp) lp2))
    (setq # (1+ #))
  )
  (setq lp2 (reverse lp2))
  (if (< (oglp-dl-pol lp1) (oglp-dl-pol lp2))
    (progn
      (oglp-numeruj-internal lp1 ht)
      (oglp-numeruj-internal lp2 ht)
    )
    (progn
      (oglp-numeruj-internal lp2 ht)
      (oglp-numeruj-internal lp1 ht)
    )
  )
);defun

(defun oglp-numeruj-internal (l ht / stnr % %g og ldlist ld) 
  (setvar "dimldrblk" "_none")
  (foreach % l
    (if (not (vl-some '(lambda (x) (equal x % *oglp-fuzz*)) *oglp-nruzyte*))
      (progn
        (if (not (tblsearch "STYLE" "GeodText"))
          (entmake '((0 . "STYLE")(100 . "AcDbSymbolTableRecord")(100 . "AcDbTextStyleTableRecord")(2 . "GeodText")(70 . 0)(40 . 0.0)(41 . 1.0)(50 . 0.25)(71 . 0)(42 . 2.5)(3 . "romans.shx")(4 . "")))
        )
        (setq %g (trans % 1 0))
        (setq og (list (+ (car %g) (* 4.0 ht)) (+ (cadr %g) (* 3.0 ht))))
        (entmake (list '(0 . "LEADER")'(100 . "AcDbEntity")'(62 . 6) '(8 . "makro-numeracja-punktow")'(100 . "AcDbLeader")'(3 . "Standard")'(71 . 0)'(72 . 0)'(73 . 0)'(74 . 0)'(75 . 0)
                       '(40 . 100.0)'(41 . 0.0)'(76 . 2)(cons 10 %g)(cons 10 og)(list 210 0.0 0.0 1.0)))
        (setq ldlist (entget (setq ld (entlast))))
        (entmake (list '(0 . "MTEXT")'(62 . 6)'(8 . "makro-numeracja-punktow")'(102 . "{ACAD_REACTORS")(cons 330  ld)'(102 . "}")'(100 . "AcDbEntity")'(100 . "AcDbMText")(cons 10 og)
                       (cons 40 ht)'(41 . 0.0)'(50 . 0.0)'(71 . 7)'(72 . 5)(cons 1 (setq *oglp-nr* (next-number *oglp-nr*)))'(7 . "GeodText")(cons 10 og)
                       '(73 . 1)'(44 . 0.8)(list 210 0.0 0.0 1.0)(list 11 1.0 0.0 0.0)))
        (entmod (subst (cons 340 (entlast)) (assoc 340 ldlist) ldlist))
        (entupd ld)
        (setq *oglp-nruzyte* (cons % *oglp-nruzyte*))
        (prompt (strcat "\nWstawiono punkt nr : " *oglp-nr*))
      );progn
    );if  
  );foreach
  (last l)
);defun
  
  
(defun oglp-dl-pol (l)
  (if (< (length l) 2)
    0.0
    (+ (distance (car l) (cadr l)) (oglp-dl-pol (cdr l)))
  )
);defun


(defun c:autonumeruj ( / ss pt ht nr  vc vs lay n ob ss lp xmin xmax ymin ymax dl h eg)
  (prompt "\nWskaz linie i polilinie do numeracji :")
  (cond
    ((null (setq ss (ssget '((0 . "LINE,LWPOLYLINE")))))
       (alert "Nie wskazano zadnych linii lub polilinii.")
       (exit)
    )
    ((null (setq pt (getpoint "\nWskaz miejsce wstawienia pierwszego numeru :")))
       (alert "Nie wskazano miejsca wstawienia pierwszego numeru.")
       (exit)
    )
    ((progn (setq ht (getreal "\nPodaj wysokosc tekstu :")) (or (null ht) (<= ht 0)))
       (alert "Bedna wysokosc tekstu.")
       (exit)
    )
    ((null (setq nr (getint "\nPodaj numer startowy :")))
       (alert "Nie podano numeru startowego.")
       (exit)
    )
    ((<= nr 0)
       (alert "Numer startowy musi byc wiekszy od zera.")
       (exit)
    )
    ((not nil)
       (setq *oglp-nr* (itoa (1- nr)))
       (setq *oglp-nruzyte* nil)
       (setq lay (getvar "clayer"))
       (command "_layer" "_m" "makro-numeracja-punktow" "")
       (setvar "clayer" lay)
       (setq *oglp-lp* nil *oglp-ldl* nil *oglp-lh* nil)
       (prompt "\nBudowa zbiorczej listy ...")
       (setq n -1)
       (while (setq ob (ssname ss (setq n (1+ n))))
         (setq eg (entget ob))
         (if (and (= "LINE" (cdr (assoc 0 (entget ob)))) (not (equal (assoc 210 eg) '(210 0 0 1) 0.000001)))
           (entmod (subst '(210 0 0 1) (assoc 210 eg) eg))
         )
         (setq lp (vl-remove nil (mapcar '(lambda (%) (if (or (= (car %) 10) (= (car %) 11)) (trans (cdr %) ob 1) nil)) (entget ob))))
         (setq xmin (caar lp) xmax xmin ymin (cadar lp) ymax ymin xp (caar lp) yp (cadar lp) xk (car (last lp)) yk (cadr (last lp)))
         (foreach % lp
           (setq x (car %) y (cadr %))
           (if (< x xmin) (setq xmin x))
           (if (> x xmax) (setq xmax x))
           (if (< y ymin) (setq ymin y))
           (if (> y ymax) (setq ymax y))
         )
         (setq dl (oglp-dl-pol lp))
         (setq h (cdr (assoc 5 (entget ob))))
         (setq *oglp-ldl* (cons (list h dl xmin xmax ymin ymax xp yp xk yk) *oglp-ldl*))
         (setq *oglp-lh* (cons h *oglp-lh*))
       )
       (prompt "\nKoniec budowy listy...")
       (print lp)
       (prompt "\nStart numeracji ...")
       (oglp-ssss pt ht)
       (alert "Autonumeracja zakoczona. Zaleca si zapisanie rysunku na dysku.")
       (princ)
    )
  );cond
);defun
  

(defun c:exportnumeracji ( / lel dokl pole dokl pole ss n ob %1 %2 zamiana odp nazwa nazwa-inicjacyjna plik-nazwa plik %)
  (setq dokl *oglp-dokl* pole 12)
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (prompt "\nWskaz elementy numeracji (leader) :")
  (setq ss (ssget '((0 . "LEADER")(8 . "makro-numeracja-punktow"))))
  (if ss
    (progn
      (setq n -1)
      (while (setq ob (ssname ss (setq n (1+ n))))
        (if (and (setq %1 (assoc 340 (entget ob))) (setq %2 (cdr %1)) (setq %1 (entget %2)) (setq %2 (cdr (assoc 1 %1))))
          (setq lel (cons (cons %2 (trans (cdr (assoc 10 (entget ob))) ob 1)) lel))
        )
      )
      (if (= 0 (length lel))
        (progn
          (alert "Brak elementow do exportu.")
          (exit)
        )
      )
      (initget "Tak Nie")
      (setq zamiana (getkword "\nZamienic x i y ? [Tak/Nie] (Tak) :"))
      (if (null zamiana) (setq zamiana "Tak"))
      (setq lel (mapcar '(lambda (x) (nth x lel)) (vl-sort-i lel '(lambda (x y) (< (atoi (car x)) (atoi (car y)))))))
      (initget 0 "Plik Ekran")
      (setq odp (getkword "\nWybierz miejsce przesyu danych [Plik/Ekran] (Ekran)"))
      (if (not odp) (setq odp "Ekran"))
      (if (= odp "Plik") (progn
        (if (/= "" (setq nazwa (getvar "SAVENAME")))
          (setq nazwa-inicjacyjna (substr nazwa 1 (- (strlen nazwa) 4)))
          (setq nazwa-inicjacyjna (strcat (getvar "DWGPREFIX")  (substr (getvar "DWGNAME") 1 (- (strlen (getvar "DWGNAME")) 4))))
        )
        (setq nazwa-inicjacyjna (strcat nazwa-inicjacyjna "-punkty"))
        (setq plik-nazwa (getfiled "Utwrz plik tekstowy" nazwa-inicjacyjna "txt" 1))
        (setq plik (open plik-nazwa "w"))
        (foreach % lel
          (write-line (strcat (oglp-tab (car %) pole) "  " (oglp-tab (urtos (if (= zamiana "Tak") (caddr %) (cadr %)) 2 dokl) pole) "  "(oglp-tab (urtos (if (= zamiana "Tak") (cadr %) (caddr %)) 2 dokl) pole)) plik)
        )
        (close plik)
        (alert (strcat "Wyeksportowano " (itoa (length lel)) " numerw."))
      ))
      (if (= odp "Ekran")
        (progn
          (foreach % lel
            (prompt (strcat "\n" (oglp-tab (car %) pole) "  "(oglp-tab (urtos (if (= zamiana "Tak") (caddr %) (cadr %)) 2 dokl) pole) "  " (oglp-tab (urtos (if (= zamiana "Tak") (cadr %) (caddr %)) 2 dokl) pole)))
          )
          (prompt (strcat "\nWyeksportowano " (itoa (length lel)) " numerw."))
        )
      )
    )
    (alert "Nie wskazano zadnych elementw numeracji.")
  );if
  (princ)
);defun

(defun oglp-tab (s m)
  (if (>= (strlen s) m)
    s
    (strcat (ciagspacji (- m (strlen s))) s)
  )
);defun

(defun c:rozstawnumery ( / lel ss n ob %1 %2 %3 %4 % nrpocz)
  (command "_undo" "_m")
  (if (/= (Gstar8-internal-s) "Gstar8-1011") (alert+close+error "\nAplikacja G2015GeoCad dziaa tylko z programem \"GstarCad2015\"." nil))
  (prompt "\nWskaz elementy numeracji (leader) :")
  (setq ss (ssget '((0 . "LEADER")(8 . "makro-numeracja-punktow"))))
  (if ss
    (progn
      (setq n -1)
      (while (setq ob (ssname ss (setq n (1+ n))))
        (if (and (setq %1 (assoc 340 (entget ob))) (setq %2 (cdr %1)) (setq %3 (entget %2)) (setq %4 (cdr (assoc 1 %3))))
          (setq lel (cons (list %4
                                %2
                                (trans (cdr (assoc 10 %3)) %2 1)
                                (trans (cdr (assoc 10 (entget ob))) ob 1)
                                ) lel))
        )
      )
      (if (= 0 (length lel))
        (progn
          (alert "Brak elementow do rozstawienia.")
          (exit)
        )
      )
      (setq nrpocz (getint "\nPodaj nr poczatkowy :"))
      (setq lel (mapcar '(lambda (x) (nth x lel)) (vl-sort-i lel '(lambda (x y) (< (atoi (car x)) (atoi (car y)))))))
      (foreach % lel
        (if (>= (atoi (car %)) nrpocz)
          (progn
            (command "_zoom" "_ce" (caddr %) (* 20.0 (cdr (assoc 40 (entget (cadr %))))))
            (grdraw (caddr %) (cadddr %) -1 1)
            (command "_move" (cadr %) "" (caddr %) pause)
          );progn
        );if
      );foreach
    );progn
    (alert "Nie wskazano zadnych elementw numeracji.")
  );if
  (princ)
);defun

(setq listaarea nil)

(defun Gstar8-ac( / dcl_id what_next ss n ob typ ob# tryb)
  (vl-load-com)
  (setq dcl_id (load_dialog "Gstar8areacalculator.dcl"))  ;Load the dialog box.
  (setq what_next 2)
  (setq cnt 1)
  (setq szerokosc 40)
  (setq ss nil)
  (while (>= what_next 2)                    ;Begin display loop.
    (if (null (new_dialog "_ac_okno_01" dcl_id)) ;Initialize dialog
      (exit)                                 ;box, exit if nil
    ); endif                                 ;returned.
    (ac:ustawliste)
    (action_tile "_ac_okno_01_plus" "(progn (setq tryb \"+\") (done_dialog 4))") ;Set action for OK.
    (action_tile "_ac_okno_01_minus" "(progn (setq tryb \"-\") (done_dialog 4))")   ;Set action for 
    (action_tile "_ac_okno_01_zero" "(progn (setq listaarea nil)(ac:ustawliste) (done_dialog 2))")
    (setq what_next (start_dialog))          ;Display dialog box.
    (cond
      ((= what_next 4)                       ;Prompt user to
        (prompt "\nWskaz obiekty ->")
        (sssetfirst nil nil)
        (setq ss (ssget))
        (setq n -1)
        (while (and ss (setq ob (ssname ss (setq n (+ 1 n)))))
      (setq typ (cdr (assoc 0 (entget ob))))
      (if (and (or (wcmatch typ "LWPOLYLINE") (= typ "CIRCLE") (= typ "SPLINE") (= typ "ARC") (= typ "ELLIPSE")))
      (progn
        (setq ob# (vlax-ename->vla-object ob))
        (setq listaarea(append listaarea (list (strcat tryb (urtos (vla-get-area ob#) 2 4)))))
      ))
    )
      )
      ((= what_next 0)
        (prompt "\nuser cancelled dialog")
      )

    )
  )
  (unload_dialog dcl_id)
  (princ)
)

(defun ac:ustawliste ( / suma el wynik ss)
  (start_list "_ac_okno_01_pop1")
  (setq suma 0.00)
  (foreach el listaarea
    (add_list el)
    (setq suma (+ suma (distof el 2)))
  )
  (setq wynik (strcat "Suma = " (urtos suma 2 4)))
  (end_list)
  (sssetfirst nil ss)
  (set_tile "_ac_okno_01_wynik" wynik)
)

(setq listalength nil)

(defun Gstar8-lc( / dcl_id what_next ss n ob typ ob# tryb end le )
  (vl-load-com)
  (setq dcl_id (load_dialog "Gstar8lengthcalculator.dcl"))  ;Load the dialog box.
  (setq what_next 2)
  (setq cnt 1)
  (setq szerokosc 40)
  (setq ss nil)
  (while (>= what_next 2)                    ;Begin display loop.
    (if (null (new_dialog "_lc_okno_01" dcl_id)) ;Initialize dialog
      (exit)                                 ;box, exit if nil
    ); endif                                 ;returned.
    (lc:ustawliste)
    (action_tile "_lc_okno_01_plus" "(progn (setq tryb \"+\") (done_dialog 4))") ;Set action for OK.
    (action_tile "_lc_okno_01_minus" "(progn (setq tryb \"-\") (done_dialog 4))")   ;Set action for 
    (action_tile "_lc_okno_01_zero" "(progn (setq listalength nil)(lc:ustawliste) (done_dialog 2))")
    (setq what_next (start_dialog))          ;Display dialog box.
    ; 
    (cond
      ((= what_next 4)                       ;Prompt user to
        (prompt "\nWskaz obiekty ->")
        (sssetfirst nil nil)
        (setq ss (ssget))
        (setq n -1)
        (while (and ss (setq ob (ssname ss (setq n (+ 1 n)))))
          (setq typ (cdr (assoc 0 (entget ob))))
          (setq ob# (vlax-ename->vla-object ob))
          (cond
            ((or (= typ "LWPOLYLINE") (= typ "LINE"))
             (setq listalength (append listalength (list (strcat tryb (urtos (vla-get-length ob#) 2 4)))))
            )
            ((or (= typ "ARC") (= typ "CIRCLE") (= typ "POLYLINE") (= typ "SPLINE") (= typ "ELLIPSE"))
             (setq end (vlax-curve-getEndParam ob#))
             (setq le (vlax-curve-getDistAtParam ob# end))
             (setq listalength (append listalength (list (strcat tryb (urtos le 2 4)))))
            )
          );cond
        )
      )
      ((= what_next 0)
        (prompt "\nuser cancelled dialog")
      )
    )
  )
  (unload_dialog dcl_id)
  (princ)
)

(defun lc:ustawliste ( / suma el wynik ss)
  (start_list "_lc_okno_01_pop1")
  (setq suma 0.00)
  (foreach el listalength
    (add_list el)
    ;(print el)
    (setq suma (+ suma (distof el 2)))
  )
  (setq wynik (strcat "Suma = " (urtos suma 2 4)))
  (end_list)
  (sssetfirst nil ss)
  (set_tile "_lc_okno_01_wynik" wynik)
)

(defun lc:insertowns (name / dwg )
  (if (setq dwg (findfile (strcat name ".dwg")))
      (progn
          ;(command "_.-insert" (strcat name "=" dwg) '(0 0 0) 1 "" 0)
          ;(entdel (entlast))
          (vla-delete
              (vla-insertblock
                  (vla-get-modelspace docRef)
                  (vlax-3D-point 0 0) dwg 1.0 1.0 1.0 0.0
              )
          )
          ;(vl-catch-all-apply 'vla-delete (list (vla-item (vla-get-blocks docRef) "Own 1")))
      )
      (princ (strcat "\nCannot find \"" name ".dwg\"."))
  )
  (princ)
)

(defun list->variantArray (ptsList / arraySpace sArray)
  (setq arraySpace
         (vlax-make-safearray
           vlax-vbdouble
           (cons 0 (- (length ptsList) 1))
         )
  )
  (setq sArray (vlax-safearray-fill arraySpace ptsList))
  (vlax-make-variant sArray)
)

;; from http://forum.dwg.ru/showthread.php?t=51822&highlight=GetObjectIdString
;;--------------------------------------------------------
;; get ObjectID irrespective of the version
;; for AutoCAD x86 or x64
;; source: https://discussion.autodesk.com/forums/message.jspa?messageID=6172961
;;--------------------------------------------------------
(defun Get-ObjectID-x86-x64  (obj / util)
  (setq	util (vla-get-Utility
	       (vla-get-activedocument (vlax-get-acad-object))))
  (if (= (type obj) 'ENAME)
    (setq obj (vlax-ename->vla-object obj))
  )
  (if (= (type obj) 'VLA-OBJECT)
    (if	(> (vl-string-search "x64" (getvar "platform")) 0)
      (vlax-invoke-method util "GetObjectIdString" obj :vlax-False)
      (rtos (vla-get-objectid obj) 2 0)
    )
  )
)




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  skrcone komendy wywoujce makra z linii komend.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun c:Gstar8-proj-p   () (Gstar8-proj-pow) )
(defun c:Gstar8-linie   () (Gstar8-wstaw-z-listy2) )
(defun c:Gstar8-ustawienia  () (Gstar8-ustawienia) )
(defun c:Gstar8-leaderxy  () (Gstar8-leaderxy) )
(defun c:Gstar8-leaderxy-ust () (Gstar8-leaderxy-ustawienia) )
(defun c:Gstar8-biezace   () (Gstar8-biezace) )
(defun c:Gstar8-globalucs () (command "_UCS" "_World") )
(defun c:Gstar8-geoducs  () (Gstar8-geoducs))
(defun c:Gstar8-opisz-krzyz () (Gstar8-opiszkrzyz) )
(defun c:Gstar8-geodimport1 () (Gstar8-geodimport nil) )
(defun c:Gstar8-geodimport2 () (Gstar8-geodimport (not nil)) )
(defun c:Gstar8-geodexport () (Gstar8-geodexport) )
(defun c:Gstar8-geodpkt1 () (Gstar8-geodpkt "GeodPkt") )
(defun c:Gstar8-geodpkt2 () (Gstar8-geodpkt "GeodPktEw") )
(defun c:Gstar8-geodpkt4 () (Gstar8-geodpkt "GeodPik") )
(defun c:Gstar8-geodpkt3 () (Gstar8-geodpkt "GeodOsn") )
(defun c:Gstar8-geodpktnext () (Gstar8-geodpkt-next) )
(defun c:Gstar8-transf  ()  (geod-transformacja) )
(defun c:g8geocadinfo () (Gstar8-info) )
(defun c:gsl () (load (findfile "G2015GeoCad.lsp")) )
 
 ; skrty klawiaturowe polece
 
(defun c:impp () (Gstar8-geodimport nil) )
(defun c:imppt () (Gstar8-geodimport (not nil)) )
(defun c:expp () (Gstar8-geodexport))
(defun c:pkt () (Gstar8-geodpkt "GeodPkt") )
(defun c:pktew () (Gstar8-geodpkt "GeodPktEw") )
(defun c:osn () (Gstar8-geodpkt "GeodOsn") )
(defun c:pik () (Gstar8-geodpkt "GeodPik") )
(defun c:opisk () (Gstar8-opiszkrzyz) )
(defun c:biez   () (Gstar8-biezace) )
(defun c:lxy  () (Gstar8-leaderxy) )
(defun c:odl () (c:Gstar8-odleglosc) )
(defun c:ppd   () (Gstar8-proj-pow) )
(defun c:acalc () (Gstar8-ac) )
(defun c:lc () (Gstar8-lc) )


(princ "\nMakra aplikacji G2015GeoCad zaadowano.")
(princ)
